#include"stdafx.h"
#include"CDatEdit.h"

// Implementazione della classe CDatEdit
// per l'input delle date nel formato gg/mm/aaaa
// By FG.

BEGIN_MESSAGE_MAP (CDatEdit, CEdit)
    ON_WM_CHAR ()
    ON_WM_KEYDOWN ()
    ON_WM_KEYUP ()
    ON_WM_SYSCHAR()
    ON_WM_SYSKEYDOWN()
    ON_WM_SYSKEYUP()
    ON_WM_SETFOCUS()
    ON_WM_KILLFOCUS()
END_MESSAGE_MAP ()

// Dati del Mese
struct datiMesi{
 int gg;
 char nom[10];
 char abbr[4];
}dMese[13]={
 0,"","",
 31,"Gennaio","Gen",
 28,"Febbraio","Feb",
 31,"Marzo","Mar",
 30,"Aprile","Apr",
 31,"Maggio","Mag",
 30,"Giugno","Giu",
 31,"Luglio","Lug",
 31,"Agosto","Ago",
 30,"Settembre","Set",
 31,"Ottobre","Ott",
 30,"Novembre","Nov",
 31,"Dicembre","Dic"};

void CDatEdit::OnChar (UINT nChar, UINT nRepCnt, UINT nFlags)
{
 if(IsValid(nChar)){
  m_Dato.SetAt(m_pos_cur,nChar);
  m_pos_cur++;
  if(m_pos_cur == 2 || m_pos_cur == 5){ 
   m_pos_cur++;
  }
  SetWindowText(m_Dato);
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetCaretPos(m_ptCaretPos);
 }
}

//Restituisce Vero se l'anno specificato  bisestile
BOOL CDatEdit::IsBisestile(int aaaa){
 // Per essere bisestile l'anno deve essere divisibile per 100 e per 4 o per 4
 int y1=aaaa / 100;
 int y2=aaaa % 100;

 if( y2 == 0){
  if(!(y1%4)){
   return TRUE;
  }
 }else{
  if(!(y2%4)){
   return TRUE;
  }
 }
 return FALSE;
}

//Controllo Validit dell' input 
BOOL CDatEdit::IsDateValid(){
 int gg,mm,aaaa;
 BOOL bBisestile;
 char msg[100];

 GetData(&gg,&mm,&aaaa);

 if(gg==0 && mm==0 && aaaa==0) //Lasciato in Bianco
  return TRUE;

 bBisestile=IsBisestile(aaaa);

 if(mm == 2 && bBisestile) //E' Bisestile
  dMese[2].gg=29;
 else if(mm == 2)
  dMese[2].gg=28;

 if(gg > dMese[mm].gg || gg < 1 || mm > 12 || mm < 1 || aaaa < 1800){
  sprintf(msg,"La data indicata (%s) non  valida !",m_Dato);
  AfxMessageBox(msg,MB_OK | MB_ICONSTOP);
  return FALSE;
 }
 return TRUE;
}

//Controllo Validit dell' input 
BOOL CDatEdit::IsValid(UINT nChar){
 
 if(m_pos_cur>9){
  MessageBeep(MB_ICONEXCLAMATION);
  return FALSE;
 }

 switch(m_pos_cur){
  case 0:
          if(nChar < '0' || nChar > '3') 
           return FALSE;
          break;

  case 3:
          if(nChar < '0' || nChar > '1') 
           return FALSE;
          break;
  case 1:
  case 4:
  case 7:
  case 8:
  case 9:
          if(nChar < '0' || nChar > '9') 
           return FALSE;
          break;
  case 6: if(nChar < '1' || nChar > '9') 
           return FALSE;
          break;
 }
 return TRUE;
}


//Imposta il campo con la data odierna
void CDatEdit::SetOggi(){
 CTime time=CTime::GetCurrentTime();
 int nAnno=time.GetYear();
 int nMese=time.GetMonth();
 int nGiorno=time.GetDay();
 m_Dato.Format("%0.2d/%0.2d/%4d",nGiorno,nMese,nAnno);
 m_pos_cur=0;
 m_ptCaretPos.x=(m_cxChar*m_pos_cur);
 SetCaretPos(m_ptCaretPos);
}

//Imposta il valore del campo con la data specificata nella
//stringa strDate (gg/mm/aaaa)
void CDatEdit::SetStrData(CString strDate){
 m_Dato=strDate;
 m_pos_cur=0;
 m_ptCaretPos.x=(m_cxChar*m_pos_cur);
 SetCaretPos(m_ptCaretPos);
}

//Imposta il valore del campo con la data specificata 
//dal giorno,mese e anno (4 cifre)
void CDatEdit::SetData(int gg, int mm, int aaaa){
 m_Dato.Format("%0.2d/%0.2d/%4d",gg,mm,aaaa);
 m_pos_cur=0;
 m_ptCaretPos.x=(m_cxChar*m_pos_cur);
 SetCaretPos(m_ptCaretPos);
}


//Imposta il valore del campo con la data specificata 
//dal giorno,mese e anno (4 cifre)
void CDatEdit::GetData(int *gg, int *mm, int *aaaa){
 
 // m_dato
 // gg/mm/aaaa
 // 0123456789

 char fit[5];
 fit[0]=m_Dato[3]; //mm
 fit[1]=m_Dato[4];
 fit[2]='\0';
 (*mm)=atoi(fit);

 fit[0]=m_Dato[0]; //gg
 fit[1]=m_Dato[1];
 fit[2]='\0';
 (*gg)=atoi(fit);

 fit[0]=m_Dato[6]; //aaaa
 fit[1]=m_Dato[7];
 fit[2]=m_Dato[8]; //aaaa
 fit[3]=m_Dato[9];
 fit[4]='\0';
 
 (*aaaa)=atoi(fit);
}

//Trasforma la data da gg/mm/aaaa -> aaaammgg e viceversa
void CDatEdit::XformData(int Tipo,char *dtXform){
 if(Tipo==0){ // Trasforma da gg/mm/aaaa -> aaaammgg 
  dtXform[0]=m_Dato[6];
  dtXform[1]=m_Dato[7];
  dtXform[2]=m_Dato[8]; 
  dtXform[3]=m_Dato[9];
  dtXform[4]=m_Dato[3];
  dtXform[5]=m_Dato[4];
  dtXform[6]=m_Dato[0];
  dtXform[7]=m_Dato[1];
  dtXform[8]='\0';
 }else{ // DA aaaammgg -> gg/mm/aaaa
  m_Dato.SetAt(0,dtXform[6]);
  m_Dato.SetAt(1,dtXform[7]);
  m_Dato.SetAt(2,'/');
  m_Dato.SetAt(3,dtXform[4]);
  m_Dato.SetAt(4,dtXform[5]);
  m_Dato.SetAt(5,'/');
  m_Dato.SetAt(6,dtXform[0]);
  m_Dato.SetAt(7,dtXform[1]);
  m_Dato.SetAt(8,dtXform[2]); 
  m_Dato.SetAt(9,dtXform[3]);
 }
}


//Trasforma la data da gg/mm/aaaa -> aaaammgg e viceversa
void CDatEdit::XformData(int Tipo,CString& dtxfd){
 char fit[11];
 if(Tipo==0){ // Trasforma da gg/mm/aaaa -> aaaammgg 
  XformData(Tipo,fit);
  dtxfd=fit;
 }else{ // DA aaaammgg -> gg/mm/aaaa
  strcpy(fit,dtxfd);
  XformData(Tipo,fit);
 }
}


//Costruttore
CDatEdit::CDatEdit(){
 m_pos_cur=0;
 m_Dato="  /  /    ";
 m_ptCaretPos=(1,1);
}

//Reinizzializza l'oggetto
void CDatEdit::Reset(){
 m_pos_cur=0;
 m_Dato="  /  /    ";
 m_ptCaretPos=(1,1);
}



void CDatEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
 if(nChar == VK_BACK && m_pos_cur>0){
  m_pos_cur--;
  if(m_pos_cur == 2 || m_pos_cur == 5){ 
   m_pos_cur--;
  }
  m_Dato.SetAt(m_pos_cur,32); 
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetWindowText(m_Dato);
  SetCaretPos(m_ptCaretPos);
  return;
 }

 if(nChar == VK_RIGHT && m_pos_cur<=9){
  m_pos_cur++;
  if(m_pos_cur == 2 || m_pos_cur == 5){ 
   m_pos_cur++;
  }
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetCaretPos(m_ptCaretPos);
 }
 
 if(nChar == VK_LEFT && m_pos_cur>0){
  m_pos_cur--;
  if(m_pos_cur == 2 || m_pos_cur == 5){ 
   m_pos_cur--;
  }
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetCaretPos(m_ptCaretPos);
 }
}

void CDatEdit::OnSysKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags){
 CEdit::OnSysKeyDown(nChar,nRepCnt,nFlags); 
}

void CDatEdit::OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags){
 CEdit::OnSysKeyUp(nChar,nRepCnt,nFlags); 
}

void CDatEdit::OnSysChar(UINT nChar,UINT nRepCnt, UINT nFlags){
 CEdit::OnSysChar(nChar,nRepCnt,nFlags); 
}

void CDatEdit::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags){
 CEdit::OnKeyUp(nChar,nRepCnt,nFlags); 
}

void CDatEdit::OnSetFocus(CWnd *pOldWnd){
 TEXTMETRIC tm;
 CClientDC dc(this);
 dc.GetTextMetrics(&tm);

 m_cxChar=tm.tmAveCharWidth-1;
 m_cyChar=tm.tmHeight;

 CreateSolidCaret (max (1, ::GetSystemMetrics (SM_CXBORDER)),m_cyChar);
 SetCaretPos (m_ptCaretPos);
 ShowCaret ();
}

void CDatEdit::OnKillFocus(CWnd *pNewWnd){
 HideCaret ();
 m_ptCaretPos = GetCaretPos ();
 ::DestroyCaret ();

 if(!IsDateValid()){ //Errore, Data Inserita non corretta
  m_pos_cur=0;
  m_Dato="  /  /    ";
  SetWindowText(m_Dato);
  SetFocus();  
  m_ptCaretPos=(1,1);
  SetCaretPos (m_ptCaretPos);
 }

 GetParent()->SendMessage(WM_COMMAND,MAKEWPARAM(m_ID,EN_KILLFOCUS),(LPARAM)this->m_hWnd);
}

void CDatEdit::Refresh(){
 SetWindowText(m_Dato);
}
//Fine



