//{{AFX_INCLUDES()
#include "si_comm.h"
//}}AFX_INCLUDES
#if !defined(AFX_CDLGCFGCELL_H__4E5B4F13_332F_11D5_A128_0050041038C1__INCLUDED_)
#define AFX_CDLGCFGCELL_H__4E5B4F13_332F_11D5_A128_0050041038C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CDlgCfgCell.h : header file
//
// By Francesco Germinara (c) 2001
/////////////////////////////////////////////////////////////////////////////
// CDlgCfgCell dialog

class CDlgCfgCell : public CDialog
{
// Construction
public:
	CDlgCfgCell(CWnd* pParent = NULL);   // standard constructor


	//Main functions
	void TestPhoneComm(); //Test configuration parameters for serial communication with phone
	CString ReceiveData(); //Receive Command String Result
	BOOL SendData(CString strCmd); //FALSe=Data transmitted TRUE=Fail to transmit data
	void CheckResult(CString strResult,CString& strCmdId,CString& strValue,CString& strErr); //Check return code after a AT command is issue
	int ReadSMS(CStringArray& saMsg,CStringArray& saID,CStringArray& saSTS,CStringArray& saTel,CStringArray& saDate,CStringArray& saTime,CStatic * pLabelOperSts=NULL); //Read all message received
	BOOL SetMemoryMsg(BOOL bSIM); //Set Use of phone memory or SIM memory
	int DeleteSMS(CString msgID); //Delete message ID from phone memory

	//Helper functions 
	CString GetStrVal(CString& strResult); //Parse single value 
	void TrasfSemiOct(CString PhoneNumber,CString& strPhoneNumber); //Conversion of octet data
	CString ConvTxtToBin(CString MsgText,int & lenMsg); //Convert text msg in PDU mode
	CString ConvBinToTxt(CString strMSGCode); //Convert PDU mode in text msg
	CString ConvDBchar(CString MsgText); //Conversion of double character code
	CString GetMsgFromPDU(CString & finalData); //Get MSG info from PDU mode

	//Temp variables
	CString strID;
	CString strSTS;
	CString strNumTel;
	CString strDate;
	CString strTime;

	// Commands for communicate with cellular
	void CloseComPort();
	void OpenComPort();
	BOOL SendSimpleCmdToPhone(CString cmd,CString& result);
	int SendSMS(CString PhoneNumber,CString MsgText,BOOL useFlashMode=FALSE);

	BOOL m_bComOk; //TRUE if comm port is present

	BOOL bFlashMode; //TRUE to enable Nokia Flash Msg support

	CSI_COMM	*m_psiSerialPort; //Serial Port

// Dialog Data
	//{{AFX_DATA(CDlgCfgCell)
	enum { IDD = IDD_DLG_CFGCELL };
	int		m_nConnectionType;
	int		m_nDataBits;
	int		m_nParityType;
	int		m_nSerialPort;
	int		m_nStopBits;
	int		m_nBaudRate;
	CString	m_strNCentroServizi;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCfgCell)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


   virtual void OnOK(); //override standard function
// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgCfgCell)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CDLGCFGCELL_H__4E5B4F13_332F_11D5_A128_0050041038C1__INCLUDED_)
