// CDlgReadSMS.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgReadSMS.h"
#include "CDlgCfgCell.h"
#include "CFGSmsParser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern union{
 struct{
  unsigned char low:4;
  unsigned char high:4;
 }nibble;
 struct{
  unsigned char b0:1;
  unsigned char b1:1;
  unsigned char b2:1;
  unsigned char b3:1;
  unsigned char b4:1;
  unsigned char b5:1;
  unsigned char b6:1;
  unsigned char b7:1;
 }bit;
 BYTE byte;
}dato;

//Conversione da WORD a BYTE'S
extern union{
 struct dataword{
  unsigned char msb;
  unsigned char lsb;
 }byte;
 WORD dw;
}word;


//La Classe Applicazione 
extern CFGSmsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgReadSMS dialog


CDlgReadSMS::CDlgReadSMS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgReadSMS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgReadSMS)
	m_stsOperazione = _T("");
	//}}AFX_DATA_INIT
}


void CDlgReadSMS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgReadSMS)
	DDX_Control(pDX, IDC_STS_OPERAZ, m_lblOper);
	DDX_Control(pDX, IDC_LST_ELEMSG, m_lstEleMsg);
	DDX_Text(pDX, IDC_STS_OPERAZ, m_stsOperazione);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgReadSMS, CDialog)
	//{{AFX_MSG_MAP(CDlgReadSMS)
	ON_BN_CLICKED(IDC_BTN_START, OnBtnStart)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgReadSMS message handlers

void CDlgReadSMS::OnBtnStart() 
{
 CString strRes;
 CDlgCfgCell dlgCfgCell(this);
 int sts=0;

 UpdateData(TRUE);
 dlgCfgCell.OpenComPort();
 saMsg.RemoveAll();
 saID.RemoveAll();
 saSTS.RemoveAll();
 saTel.RemoveAll();
 saDate.RemoveAll();
 saTime.RemoveAll();

 GetDlgItem(IDC_BTN_START)->EnableWindow(FALSE);
 GetDlgItem(IDC_LST_ELEMSG)->EnableWindow(FALSE);

 
 dlgCfgCell.SetMemoryMsg(TRUE);
 sts=dlgCfgCell.ReadSMS(saMsg,saID,saSTS,saTel,saDate,saTime,&m_lblOper);
 FillListBoxEleMsg();

 dlgCfgCell.SetMemoryMsg(FALSE);
 sts=dlgCfgCell.ReadSMS(saMsg,saID,saSTS,saTel,saDate,saTime,&m_lblOper);
 FillListBoxEleMsg();

 GetDlgItem(IDC_LST_ELEMSG)->EnableWindow(TRUE);
 GetDlgItem(IDC_BTN_START)->EnableWindow(TRUE);

 dlgCfgCell.CloseComPort();
 m_stsOperazione="Operazione terminata.";
 UpdateData(FALSE);

 //Parse data
 CString m_strParseCmd,strTelNum;
 CFGSmsParser myParser;
 for(int i=0;i < saMsg.GetSize(); i++){
  strTelNum=saTel.GetAt(i);
  strTelNum.TrimRight();
  sts=theApp.m_pTabUser->FindByNumTel(strTelNum);
  if(sts==RC_SI){ //TODO: DEVO CONTROLLARE ABILITAZIONE ECC...
   if(theApp.m_pTabUser->m_ServiceEnable == "1"){
    myParser.SetStrToParser(saMsg.GetAt(i));
    myParser.Parser(); //TRUE for Debug mode
   }
  }
 }
}

BOOL CDlgReadSMS::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    //Creo impostazione delle colonne
    CreaIntestazione(&m_lstEleMsg);

	SetTimer(IDT_CHECK_NEWMWG,1000 * atoi(theApp.m_strTmPolling),NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


//Creazione dell'intestazione di colonna
void CDlgReadSMS::CreaIntestazione(CListCtrl *m_Listview){
 LV_COLUMN lvc; //Crea la struttura per la gestione delle colonne
 lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
 lvc.fmt  = LVCFMT_LEFT;

 //Attivo visualizzazione della barra su tutti i campi 
 ListView_SetExtendedListViewStyle(m_Listview->m_hWnd,LVS_EX_FULLROWSELECT);

 m_IntTabMsg.setnumcol(6);

 m_IntTabMsg.setlargcolV(0,90);
 m_IntTabMsg.setlargcolS(0,20);
 m_IntTabMsg.setdesccol(0,"Ricevuto da ");

 m_IntTabMsg.setlargcolV(1,0);
 m_IntTabMsg.setlargcolS(1,60);
 m_IntTabMsg.setdesccol(1,"Stato");

 m_IntTabMsg.setlargcolV(2,200);
 m_IntTabMsg.setlargcolS(2,60);
 m_IntTabMsg.setdesccol(2,"Messaggio");

 m_IntTabMsg.setlargcolV(3,0);
 m_IntTabMsg.setlargcolS(3,60);
 m_IntTabMsg.setdesccol(3,"Schedulato");

 m_IntTabMsg.setlargcolV(4,80);
 m_IntTabMsg.setlargcolS(4,6);
 m_IntTabMsg.setdesccol(4,"Data Ric.");

 m_IntTabMsg.setlargcolV(5,80);
 m_IntTabMsg.setlargcolS(5,5);
 m_IntTabMsg.setdesccol(5,"Ora Ric.");

 int i=0;
 for(i=0;i<m_IntTabMsg.getnumcol();i++){
  lvc.cx=m_IntTabMsg.getlargcolV(i);
  lvc.pszText=m_IntTabMsg.getdesccol(i);
  lvc.iSubItem = i; 
  m_Listview->InsertColumn(i,&lvc);
 }
} 


//Inserisce i record nella listview
void CDlgReadSMS::FillListBoxEleMsg(){
  LV_ITEM lvi;
  lvi.mask=LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
  lvi.iSubItem=0;
  long int nrec=0L,nrectot=0L;
 
  //Inserisco dati dei singoli record
  m_lstEleMsg.DeleteAllItems();
  UpdateData(FALSE);
  nrec=0;
  nrectot=saTel.GetSize();
  for(nrec=0; nrec < nrectot; nrec++){
   lvi.iItem=nrec; 
   lvi.pszText="";
   lvi.cchTextMax=5;
   lvi.lParam = (LPARAM) nrec; 
   lvi.iImage = 0; 
   m_lstEleMsg.InsertItem(&lvi);

   saMsg,saID,saSTS,saTel,saDate,saTime;

   m_lstEleMsg.SetItemText(nrec,0,saTel.GetAt(nrec));
   m_lstEleMsg.SetItemText(nrec,2,saMsg.GetAt(nrec));
   m_lstEleMsg.SetItemText(nrec,4,saDate.GetAt(nrec));
   m_lstEleMsg.SetItemText(nrec,5,saTime.GetAt(nrec));
  }
}

void CDlgReadSMS::OnTimer(UINT nIDEvent) 
{
	CBseData dtAttuale;
 if(nIDEvent == IDT_CHECK_NEWMWG){
  KillTimer(nIDEvent);

		dtAttuale.Oggi();
	 theApp.m_bseDataStart.SetDataAAAAMMGG();
		dtAttuale.SetDataAAAAMMGG();
  
		if(theApp.m_bseDataStart.data != dtAttuale.data){
		 //Controllo stato abilitazione servizi x utenti....
			ChkServiceEnabled();

			theApp.m_bseDataStart.Oggi();
		}

  OnBtnStart();

  Sleep(1000);

  //Controllo stato Ingressi digitali...
  //per gli utenti che hanno la notifica, invio lo stato...
  //Elenco Utenti del gruppo
		CString qry,PhoneNumber,IDSendTo;
  int nValue=0;
  int nBit=0;
  int nLpt=0;
  int mask=0x1;
  int nVal=0;
		BOOL status=FALSE;
		qry="SELECT * FROM CFGUSER WHERE CMNotifyEnable='1' order by IdUser";
		theApp.m_pTabUser->Open(CRecordset::dynamic,qry,CRecordset::none);
		if(theApp.m_pTabUser->IsOpen()){
			while(!theApp.m_pTabUser->IsEOF()){ 
    nBit=atoi(theApp.m_pTabUser->m_nBits);
    nLpt=atoi(theApp.m_pTabUser->m_nLpt);
				if(nLpt < 0 || nLpt > 2)
					 goto SKIP;
				if(nBit < 0 || nBit > 8)
					 goto SKIP;

    if(theApp.m_naLptAddr[nLpt] > 0) { 
					PhoneNumber = theApp.m_pTabUser->m_phoneNumber;
					PhoneNumber.TrimRight();
   		IDSendTo = theApp.m_pTabUser->m_UsrName;
					IDSendTo.TrimRight();
					nValue=theApp.m_fgHwSms.ReadDataINP(theApp.m_naLptAddr[nLpt]);

					if( nValue != atoi(theApp.m_pTabUser->m_nLastValue) ){
						theApp.m_pTabUser->UpdateLastValue(nValue);
						//OK, SEND sms
						int sts=0,nB=0;
						BOOL stsDevice=FALSE;
						CString desDevice,strMemAddr,strNbit,strType;
						CString strSMSToSend,strStatus,stsFit;
						word.dw = nValue;
						stsDevice=theApp.m_fgHwSms.GetBit(nBit);
						strMemAddr.Format("%d",nLpt);
						strNbit.Format("%d",nBit);
						strType="1"; //Input
						sts=theApp.m_pTabCfgIO->LoadDati(strMemAddr,strNbit,strType);
						desDevice="";
						if(sts==RC_SI)
							desDevice=theApp.m_pTabCfgIO->m_des;
						desDevice.TrimRight();
						if(stsDevice)
							strSMSToSend.Format("%s acceso-B%d Inp: ",desDevice,nBit);
						else
							strSMSToSend.Format("%s spento-B%d Inp: ",desDevice,nBit);

						//Check status Bits of Input Lines
						strStatus="On=";
						for(nB=7; nB>=0; nB--){
							if(theApp.m_fgHwSms.GetBit(nB)==1){
								stsFit.Format("%d,",nB);
								strStatus+=stsFit;
							}
						}
						strStatus.SetAt(strStatus.GetLength() -1 ,0x0);
						strSMSToSend+=strStatus;
						theApp.m_pTabUser->m_phoneNumber.TrimRight();

						CDlgCfgCell dlgCfgCell;
						dlgCfgCell.OpenComPort();
						status=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,strSMSToSend,atoi(theApp.m_pTabUser->m_CMFlashMode));
						dlgCfgCell.CloseComPort();
			 		if(status!=0)
				 		break;
						Sleep(500);
					}
				}
SKIP:
   	theApp.m_pTabUser->MoveNext();
   }
   theApp.m_pTabUser->Close();
  }

  SetTimer(IDT_CHECK_NEWMWG,1000 * atoi(theApp.m_strTmPolling),NULL);
 }

}

//Controllo lo stato dei servizi... che scadono nel giorno... e li disabilito.
void CDlgReadSMS::ChkServiceEnabled(){
 CBseData dtToday;
 dtToday.Oggi();
 dtToday.SetDataAAAAMMGG();
 CString qry,strSMSToSend;
 int status=0;
 qry="SELECT * FROM CFGUSER WHERE ServiceEnable='1' AND ExpirationDate='"+dtToday.data+"' order by IdUser";
 theApp.m_pTabUser->Open(CRecordset::dynamic,qry,CRecordset::none);
 if(theApp.m_pTabUser->IsOpen()){
  while(!theApp.m_pTabUser->IsEOF()){ 
   theApp.m_pTabUser->UpdateServiceEnable(FALSE);
   strSMSToSend="Il servizio  scaduto.Contattare il responsabile per richiedere nuova abilitazione.Grazie per aver utilizzato fgSms."; 
   CDlgCfgCell dlgCfgCell;
   dlgCfgCell.OpenComPort();
   status=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,strSMSToSend,atoi(theApp.m_pTabUser->m_CMFlashMode));
   dlgCfgCell.CloseComPort();
   if(status!=0)
	break;
   Sleep(500);
   theApp.m_pTabUser->MoveNext();
  }
  theApp.m_pTabUser->Close();
 }
}