/*
Module : CFGSmsCmds.cpp
Purpose: Parser FGSMS token 
Created: Francesco Germinara (c) 2001

Copyright (c) 2001 by SofTech di Germinara Francesco
All rights reserved.

Date: 24/04/2001

*/
#include "stdafx.h"
#include "FGSms.h"
#include "CDlgCfgCell.h"
#include "CQPUtils.h"
#include "CBseData.h"
#include "CDlgWriteSMS.h"
#include "smtp.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

extern BOOL SMSOptFind(CStringArray& Opts,CString& option); //Defined in this module
extern BOOL SMSOptFind(CString& Opts,CString& option); //Defined in this module

extern union{
 struct{
  unsigned char low:4;
  unsigned char high:4;
 }nibble;
 struct{
  unsigned char b0:1;
  unsigned char b1:1;
  unsigned char b2:1;
  unsigned char b3:1;
  unsigned char b4:1;
  unsigned char b5:1;
  unsigned char b6:1;
  unsigned char b7:1;
 }bit;
 BYTE byte;
}dato;

//Conversione da WORD a BYTE'S
extern union{
 struct dataword{
  unsigned char msb;
  unsigned char lsb;
 }byte;
 WORD dw;
}word;



//At this point User Table is positioned to valid user record

//#PM 
CString PM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 CString errStr;
 CString recipient;
 CString textmsg;
 CString toCC;
 CString subject;

 nParms=cmdParams.GetSize();

 //Check Syntax
 if(nParms!= 3 && nParms != 0){
  errStr.Format("#PM: Invalid parameter number (%d). Must be 0 or 3.",nParms);
 }
 if((nParms== 0) && errStr.IsEmpty()) { 
   //TODO: Future use
   //Get queue information
   //Send to cellular	 
   //Perform operation
   //AfxMessageBox("#PM: ");
 }
 if((nParms== 3) && errStr.IsEmpty()) { //Recipient are mandatory
  errStr="";
  recipient=cmdParams.GetAt(0);
  //toCC=cmdParams.GetAt(1);
  subject=cmdParams.GetAt(1);
  textmsg=cmdParams.GetAt(2);
  if(recipient.IsEmpty())
   errStr+="#PM: No Recipient!\n";

  //Perform operation
  //AfxMessageBox("#PM: To: "+recipient+"\nSubject: "+subject+"\nMessage: "+textmsg);
  //TODO: Send to Internet MailServer ...

 theApp.m_strSubject=subject;
 theApp.m_strSubject.TrimRight();

 theApp.m_strMsg=textmsg;
 theApp.m_strMsg.TrimRight();

 theApp.m_strDisplayName=theApp.m_pTabUser->m_UsrName;
 theApp.m_strDisplayName.TrimRight();

 theApp.m_strMittente=theApp.m_pTabUser->m_mailAddress;
 theApp.m_strMittente.TrimRight();

 theApp.m_strDestinatario=recipient;
 theApp.m_strDestinatario.TrimRight();

 CString domainName=theApp.m_pTabUser->m_mailAddress;
 int pos=0,sts=0;
 domainName.TrimRight();
 pos=domainName.Find("@");
 if(pos >= 0)
  domainName=domainName.Mid(pos+1);

 sts=theApp.m_pTabSMTPSrv->SearchSrvName(domainName);
 if(sts==RC_SI){
  theApp.m_strSMTPsrv=theApp.m_pTabSMTPSrv->m_SrvName;
  theApp.m_strSMTPsrv.TrimRight();
 }else
  theApp.m_strSMTPsrv="";

 if(theApp.m_strSMTPsrv.IsEmpty() || theApp.m_strMittente.IsEmpty()|| theApp.m_strDestinatario.IsEmpty()){
  errStr.Format("#PM: No valid data. From: [%s] To: [%s] SmtpSrv:[%s]",theApp.m_strMittente,theApp.m_strDestinatario,theApp.m_strSMTPsrv);
  return errStr;
 }

 CWaitCursor wc;
 CSMTPMessage* pMessage = theApp.CreateMessage();
 CSMTPConnection connection;

 BOOL bConnect = connection.Connect(theApp.m_strSMTPsrv, theApp.m_Authenticate, theApp.m_sUsername, theApp.m_sPassword, theApp.m_nPort, theApp.m_sBoundIP);
 if(!bConnect){
  errStr.Format("#PM: Connessione con server fallita");
   //Tidy up the heap memory
  delete pMessage;
  return errStr;
 }else{
  //Send the message
  if(!connection.SendMessage(*pMessage)){
   errStr.Format(_T("Impossibile inviare messaggio!\nRisposta:%s"), connection.GetLastCommandResponse());
   //Tidy up the heap memory
   delete pMessage;
   return errStr;
  }
 }
 //Tidy up the heap memory
 delete pMessage;


 CBseData dtConv;
 CString flgSts,strID;
 dtConv.Oggi();
 dtConv.SetDataAAAAMMGG();
 flgSts="S";
 strID="eMail";
 theApp.m_pTabStoricoMsg->Insert(
        strID,
	    theApp.m_strMsg,
	    flgSts,
	    theApp.m_strDestinatario,
	    dtConv.data,
	    dtConv.ora,
	    theApp.m_pTabUser->m_IdUser
   );
 }
 return errStr;
};

//#CM 
CString CM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nOpts=0;
 CString errStr;
 CString strOpt;

 nOpts=cmdOptions.GetSize();

 //Check Syntax

 /*Options allowed
   /xxx or /s
  */

 if(nOpts> 2){
  errStr.Format("#CM: Invalid option number (%d). Must be less or equal 2.",nOpts);
 }

 //Remove invalid option 
 CStringArray validOpt;
 BOOL xOpt=FALSE,nOpt=FALSE;
 for(int j=0; j< nOpts; j++){
  strOpt = cmdOptions.GetAt(j);
  if(strOpt=="s")
   validOpt.Add(strOpt);
  if((atoi(strOpt)>0 && atoi(strOpt)<=99) && !xOpt){
   xOpt=TRUE;
   validOpt.Add(strOpt);
  }
 }
 nOpts=validOpt.GetSize();
 if(errStr.IsEmpty()){ 
   // - Check for new mail...
   int nDivMsgToSent=0;
   strOpt="value";
   BOOL bNumDivMsg=SMSOptFind(validOpt,strOpt); //Find the numeric option, if exist...
   if(bNumDivMsg){
	nDivMsgToSent=atoi(strOpt)-1; //0 based
	if(nDivMsgToSent<0 || nDivMsgToSent > 99) //error
     bNumDivMsg=FALSE;
   }
   //Get Info on ther->m_phone User...
   theApp.m_pTabUser->m_mailPOP3svr.TrimRight();
   theApp.m_pTabUser->m_mailAccount.TrimRight();
   theApp.m_pTabUser->m_mailPassword.TrimRight();
   theApp.m_pTabUser->m_phoneNumber.TrimRight();
   if(!theApp.p3.Connect(theApp.m_pTabUser->m_mailPOP3svr,theApp.m_pTabUser->m_mailAccount,theApp.m_pTabUser->m_mailPassword)){
    theApp.CheckError();
   	errStr=theApp.p3.GetLastCommandResponse();
    return errStr;
   }
   Sleep(100L);
   if(!theApp.p3.Noop()){
    theApp.CheckError();
   	errStr=theApp.p3.GetLastCommandResponse();
    return errStr;
   }
   int nMails;
   int nSize;
   if(!theApp.p3.Statistics(nMails, nSize)){
    theApp.CheckError();
   	errStr=theApp.p3.GetLastCommandResponse();
    return errStr;
   }
   CString m_strInfo,strNmes,strSizemes;
   CString strSMSToSend("Nessun messaggio presente!"),strFit;
   //m_strInfo.Format("N. messaggi presenti: %d Dimensione: %d",nMails,nSize);
   //AfxMessageBox(m_strInfo);
   if(nMails>0) 
	   strSMSToSend="";
   for(int nMsg=1; nMsg <= nMails; nMsg++){
    CPop3Message message;
    DWORD dwSize;
    if(!theApp.p3.GetMessageSize(nMsg, dwSize)){
     theApp.CheckError();
	    errStr=theApp.p3.GetLastCommandResponse();
    }else{
     if(!theApp.p3.Retrieve(nMsg, message)){
      theApp.CheckError();
	     errStr=theApp.p3.GetLastCommandResponse();
     }
	    strOpt="s";
	    BOOL bShortForm=SMSOptFind(validOpt,strOpt); //Find the s option...
	    if(atoi(theApp.m_pTabUser->m_CMShortMode) || bShortForm) //Check Server Option
	     strFit.Format("%d %s",nMsg,message.GetFrom());
     else
	     strFit.Format("#%d-%d %d %s",nMsg,nMails,dwSize,message.GetFrom());
     strSMSToSend+=strFit;
	    strSMSToSend.TrimRight();
				}
   }
//   AfxMessageBox(strSMSToSend);
   if(!theApp.p3.Disconnect()){
    theApp.CheckError();
   }

   //OK, SEND sms
   int sts=0;
   CDlgCfgCell dlgCfgCell;
   dlgCfgCell.OpenComPort();
   //Spilt message for send via SMS ...
   theApp.m_spmsgDivided.SetMsg(strSMSToSend);
   int nElement=theApp.m_spmsgDivided.SplitMsg();
   CString msgToSent;
   if(atoi(theApp.m_pTabUser->m_CMOnlyOne) && !bNumDivMsg){ //Check Server Option
    nElement=1;
	strFit.Format("N.DivMsg: %d ",nElement);
	strFit+=strSMSToSend;
	strSMSToSend=strFit;
	theApp.m_spmsgDivided.SetMsg(strSMSToSend);
   }
   for(int nIndex = 0; nIndex<nElement; nIndex++){
	if(bNumDivMsg){
	 if(nDivMsgToSent==nIndex){
      msgToSent=theApp.m_spmsgDivided.m_astr.GetAt(nIndex);
      sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,msgToSent,atoi(theApp.m_pTabUser->m_CMFlashMode));
      break;
	 }
	}else{
     msgToSent=theApp.m_spmsgDivided.m_astr.GetAt(nIndex);
     sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,msgToSent,atoi(theApp.m_pTabUser->m_CMFlashMode));
     Sleep(200L);
	}
   }
   dlgCfgCell.CloseComPort();
   if(sts)
    errStr="Errore TX SMS";

//  for(int i=0; i< nOpts; i++){
//   fit+="/"+validOpt.GetAt(i)+" ";
//  }
//  AfxMessageBox("#CM: "+fit);
 }
 return errStr;
};

//#GM 
CString GM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 int j=0;
 int nOpts=0;
	int nDivMsgToSent=0;

 CString errStr;
 CString strNumMsg;
 CString strOpt;

 nParms=cmdParams.GetSize();
 nOpts=cmdOptions.GetSize();

 //Check Syntax
 if(nParms!= 1){
  errStr.Format("#GM: Need of message number parameter");
 }

 if(nOpts> 1){
  errStr.Format("#GM: Invalid option number (%d). Must be less or equal 1.",nOpts);
 }

 if(nOpts==1){
  strOpt = cmdOptions.GetAt(0);
  if(atoi(strOpt)<=0 || atoi(strOpt)>99){ //Not valid
   strOpt = _T("");
   nOpts=0;
  }
 }

 if((nParms== 1) && errStr.IsEmpty()) { //Recipient and Text message are mandatory
  errStr="";
  strNumMsg=cmdParams.GetAt(0);

  CString strOptValue="value";
  BOOL bNumDivMsg=SMSOptFind(strOpt,strOptValue); //Find the numeric option, if exist...
  if(bNumDivMsg){
  	nDivMsgToSent=atoi(strOpt)-1; //0 based
	  if(nDivMsgToSent<0 || nDivMsgToSent > 99) //error
    bNumDivMsg=FALSE;
		}
  //Get Info on the User...
  theApp.m_pTabUser->m_mailPOP3svr.TrimRight();
  theApp.m_pTabUser->m_mailAccount.TrimRight();
  theApp.m_pTabUser->m_mailPassword.TrimRight();
  theApp.m_pTabUser->m_phoneNumber.TrimRight();
  if(!theApp.p3.Connect(theApp.m_pTabUser->m_mailPOP3svr,theApp.m_pTabUser->m_mailAccount,theApp.m_pTabUser->m_mailPassword)){
   theApp.CheckError();
	  errStr=theApp.p3.GetLastCommandResponse();
   return errStr;
  }
  Sleep(100L);
  if(!theApp.p3.Noop()){
   theApp.CheckError();
	  errStr=theApp.p3.GetLastCommandResponse();
   return errStr;
  }

  CPop3Message message;
  CString msgFrom,msgSubject,msgDate,msgText,strSMSToSend;
  int nMsg=atoi(strNumMsg);
  DWORD dwSize=0;
  if(!theApp.p3.GetMessageSize(nMsg, dwSize)){
   theApp.CheckError();
	   errStr=theApp.p3.GetLastCommandResponse();
		}else{ //Ok, get message
    if(!theApp.p3.Retrieve(nMsg, message)){
     theApp.CheckError();
	     errStr=theApp.p3.GetLastCommandResponse();
    }
				msgFrom=message.GetFrom();
				if(!atoi(theApp.m_pTabUser->m_CMShortMode)){ //Check Server Option
				 msgSubject=message.GetSubject();
				 msgDate=message.GetDate();
				}else{
				 msgSubject="";
				 msgDate="";
				}
				//msgText=message.GetMessageText();
				msgText=message.GetBody();

                CQPUtils qp;
                char *result = qp.Decode((char *)(LPCTSTR )msgText);
				msgText=(const char *)result;
				free(result);

				//Make SMS msg
				strSMSToSend=msgFrom; strSMSToSend.TrimRight();
				strSMSToSend+=msgSubject; strSMSToSend.TrimRight();
				strSMSToSend+=msgDate; strSMSToSend.TrimRight();
				strSMSToSend+=msgText; strSMSToSend.TrimRight();

   if(!theApp.p3.Disconnect()){
    theApp.CheckError();
   }

   //OK, SEND sms
   int sts=0;
   CDlgCfgCell dlgCfgCell;
   dlgCfgCell.OpenComPort();
			CString strFit;
   //Spilt message for send via SMS ...
   theApp.m_spmsgDivided.SetMsg(strSMSToSend);
   int nElement=theApp.m_spmsgDivided.SplitMsg();
   CString msgToSent;
   if(atoi(theApp.m_pTabUser->m_CMOnlyOne) && !bNumDivMsg){ //Check Server Option
    nElement=1;
	   strFit.Format("N.DivMsg: %d ",nElement);
	   strFit+=strSMSToSend;
	   strSMSToSend=strFit;
	   theApp.m_spmsgDivided.SetMsg(strSMSToSend);
   }
   for(int nIndex = 0; nIndex<nElement; nIndex++){
	   if(bNumDivMsg){
	    if(nDivMsgToSent==nIndex){
      msgToSent=theApp.m_spmsgDivided.m_astr.GetAt(nIndex);
      sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,msgToSent,atoi(theApp.m_pTabUser->m_CMFlashMode));
      break;
					}
				}else{
     msgToSent=theApp.m_spmsgDivided.m_astr.GetAt(nIndex);
     sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,msgToSent,atoi(theApp.m_pTabUser->m_CMFlashMode));
     Sleep(200L);
				}
   }
   dlgCfgCell.CloseComPort();
   if(sts)
    errStr="Errore TX SMS";

    //AfxMessageBox("#GM: Message N: "+strNumMsg+"\nOption: /"+strOpt);
			}
 }
 return errStr;
};

//#RM  Future only ...
CString RM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 CString errStr;
 CString subject;
 CString textmsg;

 nParms=cmdParams.GetSize();

 //Check Syntax
 if(nParms!= 2){
  errStr.Format("#RM: Invalid parameter number (%d). Must be 2.",nParms);
 }
 if((nParms==2) && errStr.IsEmpty()) { 
  errStr="";
  subject=cmdParams.GetAt(0);
  textmsg=cmdParams.GetAt(1);
 
  //Perform operation
  //AfxMessageBox("#RM: \nSubject: "+subject+"\nMessage: "+textmsg);
  //TODO: Send to Internet MailServer ...
 }
 return errStr;
};

//#NM Future only ...
CString NM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nOpts=0;
 CString errStr;
 CString strOpt;

 nOpts=cmdOptions.GetSize();

 //Check Syntax

 /*Options allowed
   /on or /off or /sts
   /f

 */

 if(nOpts> 2){
  errStr.Format("#NM: Invalid option number (%d). Must be less or equal 2.",nOpts);
 }

 //Remove invalid option 
 CStringArray validOpt;
 BOOL onOpt=FALSE,nOpt=FALSE,fOpt=FALSE;
 for(int j=0; j< nOpts; j++){
  strOpt = cmdOptions.GetAt(j);
  if((strOpt=="on"||strOpt=="off"||strOpt=="sts") && !nOpt){
   if(strOpt=="on")
	onOpt=TRUE;
   nOpt=TRUE;
   validOpt.Add(strOpt);
  }
  if(strOpt=="f" && !fOpt ){
   fOpt=TRUE;
   validOpt.Add(strOpt);
  }
 }
 nOpts=validOpt.GetSize();

 //If /f is present, check also if /on is present else error
 if((fOpt  && onOpt) || (!fOpt && nOpts==1)){
  //Perform operation
  for(int i=0; i< nOpts; i++){
   fit+="/"+validOpt.GetAt(i)+" ";
   //TODO: read new mail from mailserver
   //Send info to cellular
  }
  //AfxMessageBox("#NM: "+fit);
 }else
  errStr="#NM: Invalid options";
 return errStr;
};

//#DM Future only ...
CString DM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nOpts=0;
 CString errStr;
 CString strOpt;

 nOpts=cmdOptions.GetSize();

 //Check Syntax

 /*Options allowed
   /xxx 
   /all
   /read
   /send
 */

 if(nOpts> 1){
  errStr.Format("#DM: Invalid option number (%d). Must be less or equal 1.",nOpts);
 }

 //Remove invalid option 
 CStringArray validOpt;
 BOOL xOpt=FALSE,nOpt=FALSE;
 for(int j=0; j< nOpts; j++){
  strOpt = cmdOptions.GetAt(j);
  if((strOpt=="all"||strOpt=="read"||strOpt=="sent") && !nOpt){
   nOpt=TRUE;
   validOpt.Add(strOpt);
  }
  if((atoi(strOpt)>0 && atoi(strOpt)<=999) && !xOpt){
   xOpt=TRUE;
   validOpt.Add(strOpt);
  }
 }
 nOpts=validOpt.GetSize();
 if(nOpts >=0 && nOpts <=1){
  //Perform operation
  for(int i=0; i< nOpts; i++){
   fit+="/"+validOpt.GetAt(i)+" ";
   //TODO: read new mail from mailserver
   //Send info to cellular
  }
  //AfxMessageBox("#DM: "+fit);
 }else
  errStr="#DM: Invalid options";
 return errStr;
};

//#ST Future only ...
CString ST(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 int j=0;
 int nOpts=0;

 CString errStr;
 CString strNumMsg;
 CString strTime;
 CString strOpt;

 nParms=cmdParams.GetSize();
 nOpts=cmdOptions.GetSize();

 //Check Syntax
 if(nOpts> 1){
  errStr.Format("#ST: Invalid option number (%d). Must be less or equal 1.",nOpts);
 }

 if(nOpts==1){
  strOpt = cmdOptions.GetAt(0);
  if(strOpt!="ny"){ //Not valid
   strOpt = _T("");
   nOpts=0;
  }
 }

 //Check Syntax
 if(nParms> 2 ){
  errStr.Format("#ST: Invalid parameter number (%d). Must be 0 ,1 or 2.",nParms);
 }

 if((nParms== 0) && errStr.IsEmpty()) { 
   //TODO:
   //Get schedule information
   //Send to cellular	 
   //AfxMessageBox("#ST: ");
 }


 if((nParms== 1) && errStr.IsEmpty()) { //Time or frequency is mandatory
  errStr="";
  strTime=cmdParams.GetAt(0);
 
  //Perform operation
		/*
  if(strTime.Find(":",0)!=-1) //HH:MM
   AfxMessageBox("#ST: At time: "+strTime+"\nOption: /"+strOpt);
  else
   AfxMessageBox("#ST: Every: "+strTime+" minutes."+"\nOption: /"+strOpt);
  //TODO: Add to Schedule List 
		*/
 }


 if((nParms== 2) && errStr.IsEmpty()) { //Time or frequency is mandatory
  errStr="";
  strTime=cmdParams.GetAt(0);
  strNumMsg=cmdParams.GetAt(1);

  //Perform operation
		/*
  if(strTime.Find(":",0)!=-1) //HH:MM
   //AfxMessageBox("#ST: Message N: "+strNumMsg+"\nAt time: "+strTime+"\nOption: /"+strOpt);
  else
   //AfxMessageBox("#ST: Message N: "+strNumMsg+"\nEvery: "+strTime+" minutes."+"\nOption: /"+strOpt);
  //TODO: Add to Schedule List 
		*/
 }
 return errStr;
};

//#VI 
CString VI(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int nParms=0;
 int nOpts=0;
	int sts=0;

 CString errStr;

 nParms=cmdParams.GetSize();
 nOpts=cmdOptions.GetSize();

 //Check Syntax
 if(nOpts!= 0){
  errStr.Format("#VI: No options are allowed");
 }
 if(nParms!=0){
  errStr.Format("#VI: No parameters are allowed");
 }

 if((nParms==0) && (nOpts==0) && errStr.IsEmpty()) { 
  errStr="";

  //AfxMessageBox("#VI: ");

  CString strSMSToSend;
		CBseData bseData;
		CString strCost;
		CString strNMsgSend=theApp.m_pTabUser->m_nMsgSend;
		CString strNMsgReceived=theApp.m_pTabUser->m_nMsgReceived;
		double nCostoOfService=atof(theApp.m_pTabUser->m_CostOfService);

		strCost.Format("%15.2f euro",nCostoOfService * (atoi(strNMsgSend) + atoi(strNMsgReceived)));

		bseData.SetDataR(theApp.m_pTabUser->m_ExpirationDate);
		bseData.SetVisData();

		strSMSToSend="Msg Inviati: "+strNMsgSend+" Ricevuti: "+strNMsgReceived+" Costo Attuale: "+strCost+" Servizio Scade: ";
		strSMSToSend+=bseData.data;
		strSMSToSend.TrimRight();
		int len=strSMSToSend.GetLength();
		if(len > 150)
		 strSMSToSend=strSMSToSend.Mid(0,150);
  //AfxMessageBox(strSMSToSend);
  CDlgCfgCell dlgCfgCell;
  dlgCfgCell.OpenComPort();
  sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,strSMSToSend,atoi(theApp.m_pTabUser->m_CMFlashMode));
  dlgCfgCell.CloseComPort();
  if(sts)
   errStr="Errore TX SMS";
 }
 return errStr;
};

//#UI 
CString UI(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int nParms=0;
 int nOpts=0;
 CString errStr;
 CString strSIM;
 CString strPW;
 CString strSMSToSend;
	CBseData dataScad;
	CTime tmScad;
	CTimeSpan *pTimeSpan;
	CString strDataScad;
	CString ServiceEnable;
	CString strUserId;
	CBseData bseDataOd;
	int sts=0;

 nParms=cmdParams.GetSize();

 //Check Syntax
 if(nParms!=2){
  errStr.Format("#UI: Invalid parameter number (%d). Must be 2.",nParms);
 }

 if((nParms==2) && errStr.IsEmpty()) { 
  errStr="";
  strSIM=cmdParams.GetAt(0);
  strPW=cmdParams.GetAt(1);
  if(strSIM.IsEmpty() || strPW.IsEmpty())
   errStr.Format("#UI: Invalid parameter");
  else{
   //AfxMessageBox("#UI: SIM N: "+strSIM+"\nPassword: "+strPW);
			strUserId=theApp.m_pTabUser->m_IdUser;
			
   //TODO: Check for User Identification
			theApp.m_pTabUser->m_phoneSIMNumber.TrimRight();
			theApp.m_pTabUser->m_phonePassword.TrimRight();
   if(theApp.m_pTabUser->m_phoneSIMNumber == strSIM && theApp.m_pTabUser->m_phonePassword == strPW){
				bseDataOd.Oggi();
				bseDataOd.SetDataAAAAMMGG();
				if(bseDataOd.data == theApp.m_pTabUser->m_ExpirationDate){
				 ServiceEnable="1"; //Abilitato
 			 dataScad.SetDataR(theApp.m_pTabUser->m_ExpirationDate);
	 		 pTimeSpan = new CTimeSpan(atol(theApp.m_pTabUser->m_ChkReqDays),0,0,0);
		 	 tmScad = dataScad.time + *pTimeSpan;
			  delete pTimeSpan;
			  strDataScad.Format("%4d%2d%2d",tmScad.GetYear(),tmScad.GetMonth(),tmScad.GetDay());
				 dataScad.SetDataR(strDataScad);
				 dataScad.SetVisData();
				 strSMSToSend="Ok, Rinnovo servizio effettuato. Servizio scadr il "+dataScad.data;
				}else{
				 ServiceEnable="1"; //Abilitato
			  strDataScad=theApp.m_pTabUser->m_ExpirationDate;
				 dataScad.SetDataR(theApp.m_pTabUser->m_ExpirationDate);
				 dataScad.SetVisData();
				 strSMSToSend="Abilitazione effettuata, il servizio scade il "+dataScad.data;
				}
			}else{
    strSMSToSend="Password o numero simm erraro. Per evitare problemi di accesso NON autorizzato l'utente  stato disabilitato!";
				ServiceEnable="0"; //Disbilitato
				strDataScad="        ";
			}
   theApp.m_pTabUser->UpdateExpirationDate(strUserId,ServiceEnable,strDataScad);

 		strSMSToSend.TrimRight();
   //AfxMessageBox(strSMSToSend);
   CDlgCfgCell dlgCfgCell;
   dlgCfgCell.OpenComPort();
   sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,strSMSToSend,atoi(theApp.m_pTabUser->m_CMFlashMode));
   dlgCfgCell.CloseComPort();
   if(sts)
    errStr="Errore TX SMS";
  }
 }
 return errStr;
};

//#BC
CString BC(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int nParms=0;
 int nOpts=0;
 CString errStr,strOpts;
 CString strBatch,nomeFile;
	UINT sts=0;


 if(theApp.m_pTabUser->m_STCanUseBatchCmd=="1"){

  nParms=cmdParams.GetSize();
  nOpts=cmdOptions.GetSize();


  //Check Syntax
  if(nParms!=1){
   errStr.Format("#BC: Invalid parameter number (%d). Must be 1.",nParms);
  }

  if((nParms==1) && errStr.IsEmpty()) { 
   errStr="";
   strBatch=cmdParams.GetAt(0);
   if(strBatch.IsEmpty())
    errStr.Format("#BC: Invalid parameter");
   else{
    //Build string command
	 		strOpts="";
	 		for(int nOp=0; nOp < nOpts;  nOp++){
	 			strOpts+=" "+cmdOptions.GetAt(nOp);
	 		}
   }
	 	nomeFile=strBatch;
	 	int pos=nomeFile.Find('.',0);
	 	if(pos==-1)
	 		strBatch+=".cmd"; //Default extention
	 	else
    nomeFile=strBatch.Mid(0,pos);
	 	fit=theApp.bseInfo.m_strPathPrg;
	 	fit+=strBatch;
	 	fit+=strOpts;

   //AfxMessageBox("#BC: BatchCommand: "+fit);

	 	//Execute command...
	 	sts=::WinExec(fit,SW_SHOWNORMAL);
   //if(sts)
    //errStr="Errore WinExec";
	 }
 }
 return errStr;
};

//#SM 
CString SM(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 CString errStr;
 CString recipient;
 CString textmsg;
	int sts=0;
 
 nParms=cmdParams.GetSize();

 //Check Syntax
 if(nParms!= 2 ){
  errStr.Format("#SM: Invalid parameter number (%d). Must be 2.",nParms);
 }
 if((nParms== 2) && errStr.IsEmpty()) { 
  errStr="";
  recipient=cmdParams.GetAt(0);
  textmsg=cmdParams.GetAt(1);
		recipient.TrimRight();
		textmsg.TrimRight();
  if(recipient.IsEmpty())
   errStr+="#SM: No Recipient!\n";
  else{
   //Perform operation
   //AfxMessageBox("#SM: To: "+recipient+"\nMessage: "+textmsg);
			CDlgWriteSMS dlgWriteSMS;
   sts=dlgWriteSMS.SendSMStoRecipient(recipient,textmsg);   
   if(sts)
    errStr="Errore TX SMS";
  }
 }
 return errStr;
};

//#SB
CString SB(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 int nOpts=0;
 CString errStr;
 CString memAddr;
 CString bitNum;
 CString strOpt;

 nParms=cmdParams.GetSize();

 //Check Syntax
 if(nParms!= 2){
  errStr.Format("#SB: Invalid parameter number (%d). Must be 2.",nParms);
 }

 nOpts=cmdOptions.GetSize();
 //Check Syntax
 /*Option is mandatory
   /on
   /off
   /sts
 */
 if(nOpts!= 1){
  errStr.Format("#SM: Invalid option number (%d). Must be equal 1.",nOpts);
 }else{
  strOpt = cmdOptions.GetAt(0);
  if(strOpt!="on" && strOpt!="off" && strOpt!="sts")
   errStr.Format("#SM: Invalid option");
 }
 if((nParms== 2) && errStr.IsEmpty()) { //
  errStr="";
  memAddr=cmdParams.GetAt(0);
  bitNum=cmdParams.GetAt(1);

  if(!memAddr.IsEmpty() && !bitNum.IsEmpty()){
   //Perform operation
   //AfxMessageBox("#SB: MemAddr: "+memAddr+"\nBit n: "+bitNum+"\nOption: "+strOpt);
   int nValue=0;
   int nBit=atoi(bitNum);
   int nLpt=atoi(memAddr);
   int mask=0x1;
   int nVal=0;
   if(nBit < 0 || nBit > 7){ errStr="#SB: Invalid value in nBit parameter"; return errStr; };
   if(nLpt < 0 || nLpt > 2){ errStr="#SB: Invalid value in memAddr parameter"; return errStr; };
   if(theApp.m_naLptAddr[nLpt] <= 0) { errStr="#SB: Parallel port no present!"; return errStr; };
   nValue=theApp.m_fgHwSms.ReadByteOUT(theApp.m_naLptAddr[nLpt]);
   nVal = (mask << nBit);
   if(strOpt=="on")
    nValue |= nVal;
   if(strOpt=="off")
    nValue &= ~nVal;
   if(strOpt=="off" || strOpt=="on"){
    theApp.m_fgHwSms.WriteDataOUT(theApp.m_naLptAddr[nLpt],nValue);
	   nValue=theApp.m_fgHwSms.ReadByteOUT(theApp.m_naLptAddr[nLpt]);
   }
   //Send SMS Response...
   //OK, SEND sms
   int sts=0,nB=0;
   BOOL stsDevice=FALSE;
   CString desDevice,strMemAddr,strNbit,strType;
   CString strSMSToSend,strStatus,stsFit;
   word.dw = nValue;
   stsDevice=theApp.m_fgHwSms.GetBit(nBit);
   strMemAddr.Format("%d",atoi(memAddr));
   strNbit.Format("%d",nBit);
   strType="0"; //Output
   sts=theApp.m_pTabCfgIO->LoadDati(strMemAddr,strNbit,strType);
   desDevice="";
   if(sts==RC_SI)
    desDevice=theApp.m_pTabCfgIO->m_des;
   desDevice.TrimRight();
   if(strOpt=="on"){
    if(stsDevice)
     strSMSToSend.Format("Ok, %s acceso-B%d Out: ",desDevice,nBit);
	else
     strSMSToSend.Format("Err,%s spento-B%d Out: ",desDevice,nBit);
   }
   if(strOpt=="off"){
    if(!stsDevice)
     strSMSToSend.Format("Ok, %s spento-B%d Out: ",desDevice,nBit);
	else
     strSMSToSend.Format("Err,%s acceso-B%d Out: ",desDevice,nBit);
   }
   if(strOpt=="sts"){
    if(stsDevice)
     strSMSToSend.Format("%s acceso-B%d Out: ",desDevice,nBit);
	else
     strSMSToSend.Format("%s spento-B%d Out: ",desDevice,nBit);
   }
   //Check status Bits of Output Lines
   strStatus="On=";
   for(nB=7; nB>=0; nB--){
    if(theApp.m_fgHwSms.GetBit(nB)==1){
	 stsFit.Format("%d,",nB);
     strStatus+=stsFit;
    }
   }
   strStatus.SetAt(strStatus.GetLength() -1 ,0x0);
   strSMSToSend+=strStatus;
   //AfxMessageBox(strSMSToSend);
   CDlgCfgCell dlgCfgCell;
   dlgCfgCell.OpenComPort();
   sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,strSMSToSend,atoi(theApp.m_pTabUser->m_CMFlashMode));
   dlgCfgCell.CloseComPort();
   if(sts)
    errStr="Errore TX SMS";
  }else
   errStr="#SB: Invalid parameters";
 }
 return errStr;
};

//#RI
CString RI(CStringArray& cmdParams,CStringArray& cmdOptions){
 CString fit,strResult;
 int i=0;
 int nParms=0;
 int nOpts=0;
 CString errStr;
 CString memAddr;
 CString bitNum;
 CString strOpt;

 nParms=cmdParams.GetSize();

 //Check Syntax
 if(nParms!= 2){
  errStr.Format("#SB: Invalid parameter number (%d). Must be 2.",nParms);
 }

 nOpts=cmdOptions.GetSize();
 //Check Syntax
 /*No Option 
 */
 if(nOpts!= 0){
  errStr.Format("#RI: Invalid option number (%d). Must be equal 0.",nOpts);
 }
 if((nParms== 2) && errStr.IsEmpty()) { //
  errStr="";
  memAddr=cmdParams.GetAt(0);
  bitNum=cmdParams.GetAt(1);

  if(!memAddr.IsEmpty() && !bitNum.IsEmpty()){
   //Perform operation
   //AfxMessageBox("#RI: MemAddr: "+memAddr+"\nBit n: "+bitNum);
   //TODO: Perform special function

   int nValue=0;
   int nBit=atoi(bitNum);
   int nLpt=atoi(memAddr);
   int mask=0x1;
   int nVal=0;
   if(nBit < 0 || nBit > 7){ errStr="#RI: Invalid value in nBit parameter"; return errStr; };
   if(nLpt < 0 || nLpt > 2){ errStr="#RI: Invalid value in memAddr parameter"; return errStr; };
   if(theApp.m_naLptAddr[nLpt] <= 0) { errStr="#RI: Parallel port no present!"; return errStr; };

   nValue=theApp.m_fgHwSms.ReadDataINP(theApp.m_naLptAddr[nLpt]);
   
   //Send SMS Response...
   //OK, SEND sms
   int sts=0,nB=0;
   BOOL stsDevice=FALSE;
   CString desDevice,strMemAddr,strNbit,strType;
   CString strSMSToSend,strStatus,stsFit;
   word.dw = nValue;
   stsDevice=theApp.m_fgHwSms.GetBit(nBit);
   strMemAddr.Format("%d",atoi(memAddr));
   strNbit.Format("%d",nBit);
   strType="1"; //Input
   sts=theApp.m_pTabCfgIO->LoadDati(strMemAddr,strNbit,strType);
   desDevice="";
   if(sts==RC_SI)
    desDevice=theApp.m_pTabCfgIO->m_des;
   desDevice.TrimRight();
   if(stsDevice)
    strSMSToSend.Format("%s acceso-B%d Inp: ",desDevice,nBit);
   else
    strSMSToSend.Format("%s spento-B%d Inp: ",desDevice,nBit);

   //Check status Bits of Input Lines
   strStatus="On=";
   for(nB=7; nB>=0; nB--){
    if(theApp.m_fgHwSms.GetBit(nB)==1){
	 stsFit.Format("%d,",nB);
     strStatus+=stsFit;
    }
   }
   strStatus.SetAt(strStatus.GetLength() -1 ,0x0);
   strSMSToSend+=strStatus;
   //AfxMessageBox(strSMSToSend);
   CDlgCfgCell dlgCfgCell;
   dlgCfgCell.OpenComPort();
   sts=dlgCfgCell.SendSMS(theApp.m_pTabUser->m_phoneNumber,strSMSToSend,atoi(theApp.m_pTabUser->m_CMFlashMode));
   dlgCfgCell.CloseComPort();
   if(sts)
    errStr="Errore TX SMS";
  }else
   errStr="#SB: Invalid parameters";
 }
 return errStr;
};

//Note: Use "value" for check numeric option if found, the value is in put in option argument
BOOL SMSOptFind(CStringArray& Opts,CString& option){
  int nIndex=0;
  CString tmpOpt;
  for(nIndex=0; nIndex < Opts.GetSize(); nIndex++){
   tmpOpt=Opts.GetAt(nIndex);
   if(option=="value")
	if(atoi(tmpOpt)>0)
     return TRUE;
   if(tmpOpt.Find(option)>=0)
    return TRUE;
  }
  return FALSE;
}

//Note: Use "value" for check numeric option if found, the value is in put in option argument
BOOL SMSOptFind(CString& Opts,CString& option){
  CString tmpOpt;
  tmpOpt=Opts;
  if(option=="value")
	  if(atoi(tmpOpt)>0)
    return TRUE;
   if(tmpOpt.Find(option)>=0)
    return TRUE;
  return FALSE;
}
//Fine