#include"stdafx.h"
#include"CNumEdit.h"

// Implementazione della classe CNumEdit
// Cifre tra 0-9 . , -
// By FG.
// U.A. 7/10/99

BEGIN_MESSAGE_MAP (CNumEdit, CEdit)
    ON_WM_KEYDOWN ()
    ON_WM_KEYUP ()
    ON_WM_SYSCHAR()
    ON_WM_SYSKEYDOWN()
    ON_WM_SYSKEYUP()
    ON_WM_SETFOCUS()
    ON_WM_CHAR ()
	ON_WM_KILLFOCUS()
END_MESSAGE_MAP ()

void CNumEdit::OnChar (UINT nChar, UINT nRepCnt, UINT nFlags)
{
 if(IsValid(nChar) && m_pos_cur<m_Len){
  m_Dato.TrimRight();
  if(m_pos_cur==m_Dato.GetLength())
   m_Dato+=" ";
  m_Dato.SetAt(m_pos_cur,nChar);
  m_pos_cur++;
  SetWindowText(m_Dato);
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetCaretPos(m_ptCaretPos);
 }
}

//Controllo Validit dell' input 
BOOL CNumEdit::IsValid(UINT nChar){
  int pos=0,posDec=0;
  if((nChar >= '0') && (nChar <= '9'))
   return TRUE;
  if(nChar == '.'){
   pos=m_Dato.Find('.');
   if(pos==-1)
    return TRUE;
   else
    return FALSE;
  }
  if(nChar == '-'){
   posDec=m_Dato.Find('.');
   if(posDec > m_pos_cur || posDec==-1){
    pos=m_Dato.Find('-');
    if(pos==-1){
     //Controllo se prima c'e' qualcosa
	 if(m_pos_cur>0){
	  if(m_Dato.GetAt(m_pos_cur-1)==' ')	 
       return TRUE;
	  else
       return FALSE;
	 }else
	  return TRUE;
    }else
     return FALSE;
   }
   return FALSE;
  }
 return FALSE;
}

//Restituisce il numero di decimali.
int CNumEdit::GetNDec(){
 int i=0;
 int ndec=0;
 BOOL FlgDec=FALSE;

 for(i=0; i< m_Dato.GetLength();i++){
  if(m_Dato[i]=='.'){
   FlgDec=TRUE;
   continue;
  }
  if(FlgDec)
   ndec++;
 }
 return ndec;
}

//Restituisce Vero se m_Dato  blank
BOOL CNumEdit::IsBlank(){
 int i=0;
 BOOL FlgBlk=TRUE;

 for(i=0; i< m_Dato.GetLength();i++){
  if(m_Dato[i]!=' '){
   FlgBlk=FALSE;
   break;
  }
 }
 return FlgBlk;
}

void CNumEdit::OnKillFocus(CWnd *pNewWnd){
 double val=0.0;
 val=atof(m_Dato);
 CString frm;
 frm.Format("%%%d.%df",m_Len,m_NumDec);
 m_Dato.Format(frm,val);
 HideCaret ();
 m_ptCaretPos = GetCaretPos ();
 ::DestroyCaret ();

 SetWindowText(m_Dato);

 if(!IsNumValid()){ //Errore, numero non valido
  m_Dato="";
  SetWindowText(m_Dato);
  SetFocus();  
 }
 GetParent()->SendMessage(WM_COMMAND,MAKEWPARAM(m_ID,EN_KILLFOCUS),(LPARAM)this->m_hWnd);
}

void CNumEdit::Refresh(){
 double val=0.0;
 val=atof(m_Dato);
 CString frm;
 frm.Format("%%%d.%df",m_Len,m_NumDec);
 m_Dato.Format(frm,val);
 SetWindowText(m_Dato);
}

BOOL CNumEdit::IsNumValid(){
 char msg[100];
 BOOL FlgErr=FALSE;

 if(IsBlank()) //E' Vuoto ?
  return TRUE;

 if(GetNDec() > m_NumDec){
  sprintf(msg,"Errore: Il numero massimo di decimali consentito  %d !",m_NumDec);
  MessageBox(msg,"Input Numerico",MB_OK | MB_ICONSTOP);
  FlgErr=TRUE;
 }
 if(((atof(m_Dato)>m_LimMax) || (atof(m_Dato)<m_LimMin))&&(!FlgErr)){
  sprintf(msg,"Errore: Il valore deve essere compreso tra %f e %f !",m_LimMin,m_LimMax);
  MessageBox(msg,"Input Numerico",MB_OK | MB_ICONSTOP);
  FlgErr=TRUE;
 }
 if(m_Dato.GetLength()>m_Len &&(!FlgErr)){
  sprintf(msg,"Errore: Lunghezza del campo deve essere al massimo di %d, di cui %d decimali!",m_Len,m_NumDec);
  MessageBox(msg,"Input Numerico",MB_OK | MB_ICONSTOP);
  FlgErr=TRUE;
 }

 if(FlgErr){
  m_pos_cur=0;
  m_Dato="";
  SetWindowText(m_Dato);
  SetFocus();  
  m_ptCaretPos=(1,1);
  SetCaretPos (m_ptCaretPos);
 }
 return !FlgErr;
}

void CNumEdit::OnSetFocus(CWnd *pOldWnd){
 TEXTMETRIC tm;
 CClientDC dc(this);
 dc.GetTextMetrics(&tm);

 m_cxChar=tm.tmAveCharWidth-1;
 m_cyChar=tm.tmHeight;

 CreateSolidCaret (max (1, ::GetSystemMetrics (SM_CXBORDER)),m_cyChar);

 double val=0.0;
 val=atof(m_Dato);
 CString frm;
 frm.Format("%%%d.%df",m_Len,m_NumDec);
 m_Dato.Format(frm,val);
 m_Dato.TrimLeft();
 m_Dato.TrimRight();
 SetWindowText(m_Dato);

  m_pos_cur=0;
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  m_Dato.TrimRight();
  SetWindowText(m_Dato);
  SetCaretPos(m_ptCaretPos);

 SetCaretPos(m_ptCaretPos);
 ShowCaret ();

}

//Costruttore
CNumEdit::CNumEdit(){
 m_pos_cur=0;
 m_Dato="";
 m_ptCaretPos=(1,1);
 m_Len=10; //Default
}

void CNumEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
 if(nChar == VK_BACK && m_pos_cur>0){
  strLeft =m_Dato.Mid(0,m_pos_cur-1);
  strRight=m_Dato.Mid(m_pos_cur);
  m_Dato=strLeft+strRight;
  if(m_pos_cur>=m_Dato.GetLength())
   m_pos_cur=m_Dato.GetLength();
  else
   m_pos_cur--;
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  m_Dato.TrimRight();
  SetWindowText(m_Dato);
  SetCaretPos(m_ptCaretPos);
  return;
 }
 if(nChar == VK_DELETE  && m_pos_cur>=0 && m_pos_cur<m_Dato.GetLength() ){
  strLeft =m_Dato.Mid(0,m_pos_cur);
  strRight=m_Dato.Mid(m_pos_cur+1);
  m_Dato=strLeft+strRight;
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetWindowText(m_Dato);
  SetCaretPos(m_ptCaretPos);
  return;
 }


 if(nChar == VK_HOME){
  m_pos_cur=0;
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  m_Dato.TrimRight();
  SetWindowText(m_Dato);
  SetCaretPos(m_ptCaretPos);
  return;
 }
 if(nChar == VK_END){
  m_pos_cur=m_Dato.GetLength();
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  m_Dato.TrimRight();
  SetWindowText(m_Dato);
  SetCaretPos(m_ptCaretPos);
  return;
 }

 if(nChar == VK_RIGHT && m_pos_cur<m_Dato.GetLength()){
  m_pos_cur++;
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetCaretPos(m_ptCaretPos);
 }
 
 if(nChar == VK_LEFT && m_pos_cur>0){
  m_pos_cur--;
  m_ptCaretPos.x=(m_cxChar*m_pos_cur);
  SetCaretPos(m_ptCaretPos);
 }

}
void CNumEdit::OnSysKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags){
 CEdit::OnSysKeyDown(nChar,nRepCnt,nFlags); 
}

void CNumEdit::OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags){
 CEdit::OnSysKeyUp(nChar,nRepCnt,nFlags); 
}

void CNumEdit::OnSysChar(UINT nChar,UINT nRepCnt, UINT nFlags){
 CEdit::OnSysChar(nChar,nRepCnt,nFlags); 
}

void CNumEdit::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags){
 CEdit::OnKeyUp(nChar,nRepCnt,nFlags); 
}

//Fine


