// CParInterface.cpp : implementation file
// Written by Francesco Germinara  2001-2002
// Last Update: 10-08-2001
// Please for any suggestions or comments, contact me 
// at E-Mail: franco@germinara.it or visit
// Web: http://www.germinara.it
/////////////////////////////////////////////////////
// NOTE: To access direct hardware port in NT or 2000 
//       system, please download and buy the NTPORT
//       driver.
//       NTPort Library
//       Copyright  1997-2001 Hai Li, Zeal SoftStudio.
//       E-Mail: support@zealsoftstudio.com
//       Web: http://www.zealsoftstudio.com
//
//       For 95/98 system, no drivers is necessary.
//       Enjoy yourself.
/////////////////////////////////////////////////////

#include "stdafx.h"
#include "CParInterface.h"
#include "conio.h"
#include "NTPORT.h"

#define DIRECTACCESS 2
#define DRIVERACCESS 1

#define WNT  1 //no hardware direct access  Nt Family
#define W2K  1 //no hardware direct access  2000 Family
#define WXP  1 //no hardware direct access  XP Family

#define W95  2 //hardware direct access allowed Windows 95 Family
#define W98  2 //hardware direct access allowed Windows 98 Family
#define WME  2 //hardware direct access allowed Windows Millenium Editions Family
#define W32S 2 //hardware direct access allowed Windows 3.11 Family


//Conversione BYTE-BIT'S
union{
 struct{
  unsigned char low:4;
  unsigned char high:4;
 }nibble;
 struct{
  unsigned char b0:1;
  unsigned char b1:1;
  unsigned char b2:1;
  unsigned char b3:1;
  unsigned char b4:1;
  unsigned char b5:1;
  unsigned char b6:1;
  unsigned char b7:1;
 }bit;
 BYTE byte;
}dato;

//Conversione da WORD a BYTE'S
union{
 struct dataword{
  unsigned char msb;
  unsigned char lsb;
 }byte;
 WORD dw;
}word;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParInterface dialog


CParInterface::CParInterface(CString strBaseHexPort)
{
	m_strBse = _T(strBaseHexPort);
	m_strVersioneOS = _T("");
	sscanf(m_strBse, "%x", &m_nPortBse);
	m_nWrtBit=0;

	// Get OS informations...
	GetSystemVersion(nVersione,vers,tipo,srvpack);
    m_strVersioneOS=vers+" "+srvpack;
}

void CParInterface::SetBaseAddr(CString strBaseHex){
 m_strBse = _T(strBaseHex);
 sscanf(m_strBse, "%x", &m_nPortBse);
}

void CParInterface::SetBaseAddr(int nBaseAddr){
 m_nPortBse=nBaseAddr;
 m_strBse.Format("%x",m_nPortBse);
}

//Restituisce il valore del bit specificato
int CParInterface::GetBit(int nBit){
 if(nBit<0)
  return 2; //Led Disabilitato

 if(nBit<8){
  dato.byte=word.byte.msb;
  switch(nBit){
   case 0: return dato.bit.b0;
   case 1: return dato.bit.b1;
   case 2: return dato.bit.b2;
   case 3: return dato.bit.b3;
   case 4: return dato.bit.b4;
   case 5: return dato.bit.b5;
   case 6: return dato.bit.b6;
   case 7: return dato.bit.b7;
   default: return FALSE;
  }
 }else{
  dato.byte=word.byte.lsb;
  switch(nBit){
   case  8: return dato.bit.b0; 
   case  9: return dato.bit.b1;
   case 10: return dato.bit.b2;
   case 11: return dato.bit.b3;
   case 12: return dato.bit.b4;
   case 13: return dato.bit.b5;
   case 14: return dato.bit.b6;
   case 15: return dato.bit.b7;
   default: return FALSE;
  }
 }
}


BOOL CParInterface::GetSystemVersion(int& nVersione,CString& vers,CString& tipo,CString& srvpack)
{
   OSVERSIONINFOEX osvi;
   BOOL bOsVersionInfoEx;
   nVersione = 0; //No info
   vers=_T("");
   tipo=_T("");
   srvpack=_T("");

   // Try calling GetVersionEx using the OSVERSIONINFOEX structure.
   // If that fails, try using the OSVERSIONINFO structure.

   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
      // If OSVERSIONINFOEX doesn't work, try OSVERSIONINFO.

      osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
         return FALSE;
   }

   switch (osvi.dwPlatformId)
   {
      case VER_PLATFORM_WIN32_NT:

      // Test for the product.

		 if ( osvi.dwMajorVersion <= 4 ){
            vers="Microsoft Windows NT ";
            nVersione = WNT; //
		 }

         if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 ){
            vers="Microsoft Windows 2000 ";
			nVersione = W2K; 
		 }

         if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 ){
            vers="Microsoft XP (Whistler) ";
			nVersione = WXP; //
		 }

      // Display version, service pack (if any), and build number.

         if ( osvi.dwMajorVersion <= 4 )
         {
            srvpack.Format("version %d.%d %s (Build %d)\n",
               osvi.dwMajorVersion,
               osvi.dwMinorVersion,
               osvi.szCSDVersion,
               osvi.dwBuildNumber & 0xFFFF);
         }
         else
         { 
            srvpack.Format("%s (Build %d)\n",
               osvi.szCSDVersion,
               osvi.dwBuildNumber & 0xFFFF);
         }
         break;

      case VER_PLATFORM_WIN32_WINDOWS:

         if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0)
         {
             nVersione = W95; 
             vers="Microsoft Windows 95 ";
             if ( osvi.szCSDVersion[1] == 'C' )
                tipo="OSR2 ";
         } 

         if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 10)
         {
			 nVersione = W98; 
             vers="Microsoft Windows 98 ";
             if ( osvi.szCSDVersion[1] == 'A' )
                tipo="SE ";
         } 

         if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 90)
         {
			 nVersione = WME; 
             vers="Microsoft Windows Me ";
         } 
         break;

      case VER_PLATFORM_WIN32s:
         nVersione = W32S; 
         vers="Microsoft Win32s ";
         break;
   }
   return TRUE; 
}

int CParInterface::ReadByte(int portAdd) 
{
	WORD inNum=0;

	if( nVersione == DIRECTACCESS)
	 inNum = _inp(portAdd);
    else
  	 inNum = Inport(portAdd);

	 return inNum;
}

void CParInterface::WriteByte(int portAdd,unsigned char value) 
{
	dato.byte =value;
	if( nVersione == DIRECTACCESS)
	 _outp(portAdd,dato.byte);
    else
  	 Outport(portAdd,dato.byte);
}

void CParInterface::WriteDataSingleBit(int portAdd,int nBit){
 int mask=0x1;
 int ControlPortAddr=portAdd+2;

 dato.byte = 0x0d; //1101 Set High
 if( nVersione == DIRECTACCESS)
  _outp(ControlPortAddr,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);

 dato.byte = 0x00;  //Set data bit 
 dato.byte = mask << nBit;

 if( nVersione == DIRECTACCESS)
  _outp(portAdd,dato.byte);
 else
  Outport(portAdd,dato.byte);

 dato.byte = 0x0c; //1100 Write
 if( nVersione == DIRECTACCESS)
  _outp(ControlPortAddr,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);
}


unsigned long int *pLptBsePort= (unsigned long *) 0x00000400L;

int  CParInterface::GetBsePortAddr(int memAddr){
	int nAddress=0;

	if( nVersione == DIRECTACCESS){
	 nAddress = *(pLptBsePort + (memAddr * 2));  //To test with 95 system...
	}else
     nAddress = GetLPTPortAddress(memAddr+1);
  return nAddress;
}


void CParInterface::WriteDataOUT(int portAdd,int value){
 int ControlPortAddr=portAdd+2;

 dato.byte = 0x0d; //1101 Set High

 if( nVersione == DIRECTACCESS)
  _outp(ControlPortAddr,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);

 if( nVersione == DIRECTACCESS)
  _outp(portAdd,value);
 else
  Outport(portAdd,value);

 dato.byte = 0x0c; //1100 Write
 if( nVersione == DIRECTACCESS)
  _outp(ControlPortAddr,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);
}

int CParInterface::ReadDataINP(int portAdd){
 int ControlPortAddr=portAdd+2;
 int ECRport=portAdd+1026; //ECR offset in ECP mode
 int nValue=0,stsInput=0;

 nValue = ReadByte(ECRport);
 nValue |= 0x20; //set b5 on for Bi-Dir mode of ECP
 dato.byte = nValue; 
 if( nVersione == DIRECTACCESS)
  _outp(ECRport,dato.byte);
 else
  Outport(ECRport,dato.byte);

 dato.byte = 0x2a; //101010 Enable Read 
 if( nVersione == DIRECTACCESS)
  _outp(ControlPortAddr,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);

 //READ Data
 stsInput=ReadByte(portAdd);

 return stsInput;
}


int CParInterface::ReadByteOUT(int portAdd) 
{
 WORD inNum=0;
 int stsControl=0;
 int ControlPortAddr=portAdd+2;
 stsControl=ReadByte(ControlPortAddr);
 word.dw = stsControl;
 dato.byte=word.byte.msb;
 dato.bit.b1=0;
 dato.bit.b2=0;
 dato.bit.b5=0;

 if( nVersione == DIRECTACCESS)
  _outp(ControlPortAddr,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);

 if( nVersione == DIRECTACCESS)
  inNum = _inp(portAdd); 
 else
  inNum = Inport(portAdd);

 return inNum;
}

