////////////////////////////////////////////
// Programma:
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabCfgFgSms.cpp 
// Storia:
// Data Creazione: 10/06/2001
// (c) 2001 SofTech di Germinara Francesco
////////////////////////////////////////////

#include "stdafx.h"
#include "FGSms.h"
#include "CTabCfgFgSms.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CTabCfgFgSms, CRecordset)

CTabCfgFgSms::CTabCfgFgSms(CDatabase* pdb)
	: CRecordset(pdb)
{
    //Inizializzazione dei campi, del numero di campi
	//e del tipo di gestione del database
	m_IdSess= _T("");
	m_SmtpSvr= _T("");
	m_ComPort= _T("");
	m_BaudRate= _T("");
	m_DataBit= _T("");
	m_StopBit= _T("");
	m_Parity= _T("");
	m_TypeParity= _T("");
	m_Mode= _T("");
	m_SMSCNumber= _T("");
	m_PollingTime= _T("");
	m_DirLogFiles= _T("");
	m_NameSharedMem= _T("");
	m_PassWordCfg= _T("");
	m_CfgMode= _T("");
	m_EnableLogs= _T("");
	m_UseParallelPort= _T("");
	m_ParallelPortNum= _T("");
	m_UseIOcard= _T("");

	m_nFields = 19;

	m_nDefaultType = dynamic; //dynaset
	m_pDB=pdb; //Assegno il puntatore al database aperto
	
	//Lunghezze dei campi della tabella
	m_len_IdSess= 4;
	m_len_SmtpSvr= 100;
	m_len_ComPort= 1;
	m_len_BaudRate= 10;
	m_len_DataBit= 1;
	m_len_StopBit= 1;
	m_len_Parity= 1;
	m_len_TypeParity= 1;
	m_len_Mode= 1;
	m_len_SMSCNumber= 50;
	m_len_PollingTime= 5;
	m_len_DirLogFiles= 255;
	m_len_NameSharedMem= 50;
	m_len_PassWordCfg= 10;
	m_len_CfgMode= 1;
	m_len_EnableLogs= 1;
	m_len_UseParallelPort= 1;
	m_len_ParallelPortNum= 1;
	m_len_UseIOcard= 1;
}

//Connessione con il database
CString CTabCfgFgSms::GetDefaultConnect()
{
 //Apre la connessione stabilita con il database
 return _T(m_pDB->GetConnect());
}

//Connessione con la tabella
CString CTabCfgFgSms::GetDefaultSQL()
{
 //Nessuna operazione iniziale
 return _T("");
}

//Funzione per interscambio dati da/verso tabella del DB
void CTabCfgFgSms::DoFieldExchange(CFieldExchange* pFX)
{
   	pFX->SetFieldType(CFieldExchange::outputColumn);
	 RFX_Text(pFX, _T("[IdSess]"),m_IdSess);
	if(m_nFields>1){
	 RFX_Text(pFX, _T("[SmtpSvr]"),m_SmtpSvr);
	 RFX_Text(pFX, _T("[ComPort]"),m_ComPort);
	 RFX_Text(pFX, _T("[BaudRate]"),m_BaudRate);
	 RFX_Text(pFX, _T("[DataBit]"),m_DataBit);
	 RFX_Text(pFX, _T("[StopBit]"),m_StopBit);
	 RFX_Text(pFX, _T("[Parity]"),m_Parity);
	 RFX_Text(pFX, _T("[TypeParity]"),m_TypeParity);
	 RFX_Text(pFX, _T("[Mode]"),m_Mode);
	 RFX_Text(pFX, _T("[SMSCNumber]"),m_SMSCNumber);
	 RFX_Text(pFX, _T("[PollingTime]"),m_PollingTime);
	 RFX_Text(pFX, _T("[DirLogFiles]"),m_DirLogFiles);
	 RFX_Text(pFX, _T("[NameSharedMem]"),m_NameSharedMem);
	 RFX_Text(pFX, _T("[PassWordCfg]"),m_PassWordCfg);
	 RFX_Text(pFX, _T("[CfgMode]"),m_CfgMode);
	 RFX_Text(pFX, _T("[EnableLogs]"),m_EnableLogs);
	 RFX_Text(pFX, _T("[UseParallelPort]"),m_UseParallelPort);
	 RFX_Text(pFX, _T("[ParallelPortNum]"),m_ParallelPortNum);
	 RFX_Text(pFX, _T("[UseIOcard]"),m_UseIOcard);
	}
}

//ESPORTA IN FILE ASCII
void CTabCfgFgSms::Export(CProgressCtrl *progBar=NULL){
  long nrec=0L;
  CString fit;

  //Definizione dei nomi dei files
  CString nFile,msg;
  char dati[1001];
  FILE *m_idFile;
  bool FileIsOpen;
  nFile=theApp.bseInfo.m_strPathExp;
  nFile+="CFGFGSMS.EXP";

  Open(CRecordset::dynamic,"SELECT * FROM CFGFGSMS ",CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   return;
  }
  //Apertura del file ascii
  m_idFile=fopen(nFile,"w+");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile generare il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(!IsEOF()&&FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();

	fit.Format("%4s",m_IdSess);strcpy(dati,fit);
	fit.Format("%100s",m_SmtpSvr);strcat(dati,fit);
	fit.Format("%1s",m_ComPort);strcat(dati,fit);
	fit.Format("%10s",m_BaudRate);strcat(dati,fit);
	fit.Format("%1s",m_DataBit);strcat(dati,fit);
	fit.Format("%1s",m_StopBit);strcat(dati,fit);
	fit.Format("%1s",m_Parity);strcat(dati,fit);
	fit.Format("%1s",m_TypeParity);strcat(dati,fit);
	fit.Format("%1s",m_Mode);strcat(dati,fit);
	fit.Format("%50s",m_SMSCNumber);strcat(dati,fit);
	fit.Format("%5s",m_PollingTime);strcat(dati,fit);
	fit.Format("%255s",m_DirLogFiles);strcat(dati,fit);
	fit.Format("%50s",m_NameSharedMem);strcat(dati,fit);
	fit.Format("%10s",m_PassWordCfg);strcat(dati,fit);
	fit.Format("%1s",m_CfgMode);strcat(dati,fit);
	fit.Format("%1s",m_EnableLogs);strcat(dati,fit);
	fit.Format("%1s",m_UseParallelPort);strcat(dati,fit);
	fit.Format("%1s",m_ParallelPortNum);strcat(dati,fit);
	fit.Format("%1s",m_UseIOcard);strcat(dati,fit);
   
   fputs(dati,m_idFile);
   fputs("\n",m_idFile);
   MoveNext();
  }
  Close();
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}

//IMPORTA IL FILE ASCII
void CTabCfgFgSms::Import(CProgressCtrl *progBar){
  long nrec=0L;
  CString fit;
  
  //Definizione dei nomi dei files
  CString nFile,msg;
	CString IdSess;
	CString SmtpSvr;
	CString ComPort;
	CString BaudRate;
	CString DataBit;
	CString StopBit;
	CString Parity;
	CString TypeParity;
	CString Mode;
	CString SMSCNumber;
	CString PollingTime;
	CString DirLogFiles;
	CString NameSharedMem;
	CString PassWordCfg;
	CString CfgMode;
	CString EnableLogs;
	CString UseParallelPort;
	CString ParallelPortNum;
	CString UseIOcard;

  char dati[1001];
  char *result;
  FILE *m_idFile;
  bool FileIsOpen;
  int pos=0;
  nFile=theApp.bseInfo.m_strPathImp;
  nFile+="CFGFGSMS.EXP";
  
  //Apertura del file ascii in lettura
  m_idFile=fopen(nFile,"r");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile leggere il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();
   result=fgets(dati,999,m_idFile);
   if(result==NULL)
    break;
   fit=(const char *)dati;
  
   pos=0;

	IdSess=fit.Mid(pos,4);pos+=4;
	SmtpSvr=fit.Mid(pos,100);pos+=100;
	ComPort=fit.Mid(pos,1);pos+=1;
	BaudRate=fit.Mid(pos,10);pos+=10;
	DataBit=fit.Mid(pos,1);pos+=1;
	StopBit=fit.Mid(pos,1);pos+=1;
	Parity=fit.Mid(pos,1);pos+=1;
	TypeParity=fit.Mid(pos,1);pos+=1;
	Mode=fit.Mid(pos,1);pos+=1;
	SMSCNumber=fit.Mid(pos,50);pos+=50;
	PollingTime=fit.Mid(pos,5);pos+=5;
	DirLogFiles=fit.Mid(pos,255);pos+=255;
	NameSharedMem=fit.Mid(pos,50);pos+=50;
	PassWordCfg=fit.Mid(pos,10);pos+=10;
	CfgMode=fit.Mid(pos,1);pos+=1;
	EnableLogs=fit.Mid(pos,1);pos+=1;
	UseParallelPort=fit.Mid(pos,1);pos+=1;
	ParallelPortNum=fit.Mid(pos,1);pos+=1;
	UseIOcard=fit.Mid(pos,1);pos+=1;
   
   Insert(
	 IdSess,
	 SmtpSvr,
	 ComPort,
	 BaudRate,
	 DataBit,
	 StopBit,
	 Parity,
	 TypeParity,
	 Mode,
	 SMSCNumber,
	 PollingTime,
	 DirLogFiles,
	 NameSharedMem,
	 PassWordCfg,
	 CfgMode,
	 EnableLogs,
	 UseParallelPort,
	 ParallelPortNum,
	 UseIOcard
   );
  }
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}



long int CTabCfgFgSms::Count(CString filtro){
  CWaitCursor wait;
  long nrec=0L;
  int nOldFiled=m_nFields;
  m_nFields=1;

  CString qry;
  qry="SELECT COUNT(*) FROM CFGFGSMS ";
  if(filtro!="")
   qry+=filtro;

  Open(CRecordset::dynamic,qry,CRecordset::none); //forwardOnly
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
  }else{
   
	nrec=atol(m_IdSess);

   Close();
  }

  m_nFields=nOldFiled;
  return nrec;
}

//Controlla se esiste il codice specificato, se esiste carica i dati
//nelle rispettive variabili
int CTabCfgFgSms::LoadDati(CString& IdSess){
  int sts=0;
  CString qry;
  qry="SELECT * FROM CFGFGSMS WHERE IdSess='"+IdSess+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}

//Immissione dati
int CTabCfgFgSms::Insert(
	 CString& IdSess,
	 CString& SmtpSvr,
	 CString& ComPort,
	 CString& BaudRate,
	 CString& DataBit,
	 CString& StopBit,
	 CString& Parity,
	 CString& TypeParity,
	 CString& Mode,
	 CString& SMSCNumber,
	 CString& PollingTime,
	 CString& DirLogFiles,
	 CString& NameSharedMem,
	 CString& PassWordCfg,
	 CString& CfgMode,
	 CString& EnableLogs,
	 CString& UseParallelPort,
	 CString& ParallelPortNum,
	 CString& UseIOcard
 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM CFGFGSMS WHERE IdSess='"+IdSess+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //ESISTE ?
   sts=RC_NO; 
   AddNew();
  }else{
   Edit();
   sts=RC_SI; 
  }

  //Assegno il valore ai vari campi
	m_IdSess=IdSess;
	m_SmtpSvr=SmtpSvr;
	m_ComPort=ComPort;
	m_BaudRate=BaudRate;
	m_DataBit=DataBit;
	m_StopBit=StopBit;
	m_Parity=Parity;
	m_TypeParity=TypeParity;
	m_Mode=Mode;
	m_SMSCNumber=SMSCNumber;
	m_PollingTime=PollingTime;
	m_DirLogFiles=DirLogFiles;
	m_NameSharedMem=NameSharedMem;
	m_PassWordCfg=PassWordCfg;
	m_CfgMode=CfgMode;
	m_EnableLogs=EnableLogs;
	m_UseParallelPort=UseParallelPort;
	m_ParallelPortNum=ParallelPortNum;
	m_UseIOcard=UseIOcard;
  
  //Gestione delle eccezioni
  try{
   Update(); 
  }catch( CDBException* e ){
   AfxMessageBox("Errore su Update (CFGFGSMS)\n"+e->m_strError,MB_ICONEXCLAMATION );
   e->Delete();
  }
  Close();
  return(sts);
}

//Cancellazione Singolo Dato
int CTabCfgFgSms::DeleteRec(CString& IdSess){
  int sts=RC_SI;
  CString qry;
  qry="SELECT * FROM CFGFGSMS WHERE IdSess='"+IdSess+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //esiste ?
   AfxMessageBox("Impossibile cancellare. Dato non presente!");
   sts=RC_NO;
  }else{
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Delete (CFGFGSMS)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
  }
  Close();
  return(sts);
}

//Cancello tutti i dati 
int CTabCfgFgSms::DeleteAll(){
  long nrec=0L;
  Open(CRecordset::dynamic,"SELECT * FROM CFGFGSMS ",CRecordset::none);
   if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   return RC_ERR;
  }

  //Conto il numero di record 
  while(!IsEOF()){
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su DeleteAll (CFGFGSMS) \n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
   MoveNext(); //Vado sul record successivo
  }
  Close();
  return RC_SI;
}

//Inserisce i record nella listview
int CTabCfgFgSms::MakeList(CListCtrl *m_Listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro){

  LV_ITEM lvi;
  lvi.mask=LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
  lvi.iSubItem=0;

  CString clausola;
  int nrec=0;

  clausola="SELECT * FROM CFGFGSMS ";
  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY IdSess"; break;
   default: clausola=clausola+" ORDER BY IdSess"; break;
  }
  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";
  
  Open(CRecordset::dynamic,clausola,CRecordset::none);

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   return 0;
  }

  //Inserisco dati dei singoli record
  m_Listview->DeleteAllItems();
  nrec=0;
  while(!IsEOF()){

   if(progBar!=NULL)
    progBar->StepIt();

   lvi.iItem=nrec; 
   lvi.pszText="";
   lvi.cchTextMax=5;
   lvi.lParam = (LPARAM) nrec; 
   lvi.iImage = 0; 
   m_Listview->InsertItem(&lvi);

	m_Listview->SetItemText(nrec,0,m_IdSess);
	m_Listview->SetItemText(nrec,1,m_SmtpSvr);
	m_Listview->SetItemText(nrec,2,m_ComPort);
	m_Listview->SetItemText(nrec,3,m_BaudRate);
	m_Listview->SetItemText(nrec,4,m_DataBit);
	m_Listview->SetItemText(nrec,5,m_StopBit);
	m_Listview->SetItemText(nrec,6,m_Parity);
	m_Listview->SetItemText(nrec,7,m_TypeParity);
	m_Listview->SetItemText(nrec,8,m_Mode);
	m_Listview->SetItemText(nrec,9,m_SMSCNumber);
	m_Listview->SetItemText(nrec,10,m_PollingTime);
	m_Listview->SetItemText(nrec,11,m_DirLogFiles);
	m_Listview->SetItemText(nrec,12,m_NameSharedMem);
	m_Listview->SetItemText(nrec,13,m_PassWordCfg);
	m_Listview->SetItemText(nrec,14,m_CfgMode);
	m_Listview->SetItemText(nrec,15,m_EnableLogs);
	m_Listview->SetItemText(nrec,16,m_UseParallelPort);
	m_Listview->SetItemText(nrec,17,m_ParallelPortNum);
	m_Listview->SetItemText(nrec,18,m_UseIOcard);

   nrec++;
   MoveNext();
  }
  Close();
  return nrec;
}


//Inserisce i record nella listview Virtuale
int CTabCfgFgSms::GetRecordForDispInfo(CListCtrl *m_FG,LVITEM* pItem){
	if(pItem->iSubItem == 0){ //Solo al cambio del record leggo 
		                      //dati dalla tabella
   MoveFirst();
   Move(pItem->iItem);
   if(!IsEOF()){
    //pItem->iImage = atoi(xxx); 
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_IdSess); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_SmtpSvr); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_ComPort); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_BaudRate); break; 
	case 4: lstrcpy(pItem->pszText, (LPCTSTR) m_DataBit); break; 
	case 5: lstrcpy(pItem->pszText, (LPCTSTR) m_StopBit); break; 
	case 6: lstrcpy(pItem->pszText, (LPCTSTR) m_Parity); break; 
	case 7: lstrcpy(pItem->pszText, (LPCTSTR) m_TypeParity); break; 
	case 8: lstrcpy(pItem->pszText, (LPCTSTR) m_Mode); break; 
	case 9: lstrcpy(pItem->pszText, (LPCTSTR) m_SMSCNumber); break; 
	case 10: lstrcpy(pItem->pszText, (LPCTSTR) m_PollingTime); break; 
	case 11: lstrcpy(pItem->pszText, (LPCTSTR) m_DirLogFiles); break; 
	case 12: lstrcpy(pItem->pszText, (LPCTSTR) m_NameSharedMem); break; 
	case 13: lstrcpy(pItem->pszText, (LPCTSTR) m_PassWordCfg); break; 
	case 14: lstrcpy(pItem->pszText, (LPCTSTR) m_CfgMode); break; 
	case 15: lstrcpy(pItem->pszText, (LPCTSTR) m_EnableLogs); break; 
	case 16: lstrcpy(pItem->pszText, (LPCTSTR) m_UseParallelPort); break; 
	case 17: lstrcpy(pItem->pszText, (LPCTSTR) m_ParallelPortNum); break; 
	case 18: lstrcpy(pItem->pszText, (LPCTSTR) m_UseIOcard); break; 
    }
   }
  }else{
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_IdSess); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_SmtpSvr); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_ComPort); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_BaudRate); break; 
	case 4: lstrcpy(pItem->pszText, (LPCTSTR) m_DataBit); break; 
	case 5: lstrcpy(pItem->pszText, (LPCTSTR) m_StopBit); break; 
	case 6: lstrcpy(pItem->pszText, (LPCTSTR) m_Parity); break; 
	case 7: lstrcpy(pItem->pszText, (LPCTSTR) m_TypeParity); break; 
	case 8: lstrcpy(pItem->pszText, (LPCTSTR) m_Mode); break; 
	case 9: lstrcpy(pItem->pszText, (LPCTSTR) m_SMSCNumber); break; 
	case 10: lstrcpy(pItem->pszText, (LPCTSTR) m_PollingTime); break; 
	case 11: lstrcpy(pItem->pszText, (LPCTSTR) m_DirLogFiles); break; 
	case 12: lstrcpy(pItem->pszText, (LPCTSTR) m_NameSharedMem); break; 
	case 13: lstrcpy(pItem->pszText, (LPCTSTR) m_PassWordCfg); break; 
	case 14: lstrcpy(pItem->pszText, (LPCTSTR) m_CfgMode); break; 
	case 15: lstrcpy(pItem->pszText, (LPCTSTR) m_EnableLogs); break; 
	case 16: lstrcpy(pItem->pszText, (LPCTSTR) m_UseParallelPort); break; 
	case 17: lstrcpy(pItem->pszText, (LPCTSTR) m_ParallelPortNum); break; 
	case 18: lstrcpy(pItem->pszText, (LPCTSTR) m_UseIOcard); break; 
    }
  }
  return 0;
}

//Imposta Recordset
int CTabCfgFgSms::OpenRecordSet(qtHead *m_inttab,CString filtro){
  CString clausola;
  clausola="SELECT * FROM CFGFGSMS ";

  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY IdSess"; break;
   default: clausola=clausola+" ORDER BY IdSess"; break;
  }

  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";

  if(CanBookmark())
   Open(CRecordset::dynamic,clausola,CRecordset::useBookmarks);
  else
   Open(CRecordset::dynamic,clausola,CRecordset::none);  //useBookmarks

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGFGSMS !");
   return RC_ERR; //Errore
  }
  return RC_SI;   //OK
}


/////////////////////////////////////////////////////////////////////////////
// CTabCfgFgSms Diagnostica

#ifdef _DEBUG
void CTabCfgFgSms::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTabCfgFgSms::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001
