////////////////////////////////////////////
// Programma:
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabCfgIO.cpp 
// Storia:
// Data Creazione: 21/10/2001
// (c) 2001 SofTech di Germinara Francesco
////////////////////////////////////////////

#include "stdafx.h"
#include "FGSms.h"
#include "CTabCfgIO.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CTabCfgIO, CRecordset)

CTabCfgIO::CTabCfgIO(CDatabase* pdb)
	: CRecordset(pdb)
{
    //Inizializzazione dei campi, del numero di campi
	//e del tipo di gestione del database
	m_memAddr= _T("");
	m_nBit= _T("");
	m_type= _T("");
	m_des= _T("");

	m_nFields = 4;

	m_nDefaultType = dynamic; //dynaset
	m_pDB=pdb; //Assegno il puntatore al database aperto
	
	//Lunghezze dei campi della tabella
	m_len_memAddr= 1;
	m_len_nBit= 1;
	m_len_type= 1;
	m_len_des= 15;
}

//Connessione con il database
CString CTabCfgIO::GetDefaultConnect()
{
 //Apre la connessione stabilita con il database
 return _T(m_pDB->GetConnect());
}

//Connessione con la tabella
CString CTabCfgIO::GetDefaultSQL()
{
 //Nessuna operazione iniziale
 return _T("");
}

//Funzione per interscambio dati da/verso tabella del DB
void CTabCfgIO::DoFieldExchange(CFieldExchange* pFX)
{
   	pFX->SetFieldType(CFieldExchange::outputColumn);
	 RFX_Text(pFX, _T("[memAddr]"),m_memAddr);
	if(m_nFields>1){
	 RFX_Text(pFX, _T("[nBit]"),m_nBit);
	 RFX_Text(pFX, _T("[type]"),m_type);
	 RFX_Text(pFX, _T("[des]"),m_des);
	}
}

//ESPORTA IN FILE ASCII
void CTabCfgIO::Export(CProgressCtrl *progBar=NULL){
  long nrec=0L;
  CString fit;

  //Definizione dei nomi dei files
  CString nFile,msg;
  char dati[1001];
  FILE *m_idFile;
  bool FileIsOpen;
  nFile=theApp.bseInfo.m_strPathExp;
  nFile+="CFGIO.EXP";

  Open(CRecordset::dynamic,"SELECT * FROM CFGIO ",CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   return;
  }
  //Apertura del file ascii
  m_idFile=fopen(nFile,"w+");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile generare il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(!IsEOF()&&FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();

	fit.Format("%1s",m_memAddr);strcpy(dati,fit);
	fit.Format("%1s",m_nBit);strcat(dati,fit);
	fit.Format("%1s",m_type);strcat(dati,fit);
	fit.Format("%15s",m_des);strcat(dati,fit);
   
   fputs(dati,m_idFile);
   fputs("\n",m_idFile);
   MoveNext();
  }
  Close();
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}

//IMPORTA IL FILE ASCII
void CTabCfgIO::Import(CProgressCtrl *progBar){
  long nrec=0L;
  CString fit;
  
  //Definizione dei nomi dei files
  CString nFile,msg;
	CString memAddr;
	CString nBit;
	CString type;
	CString des;

  char dati[1001];
  char *result;
  FILE *m_idFile;
  bool FileIsOpen;
  int pos=0;
  nFile=theApp.bseInfo.m_strPathImp;
  nFile+="CFGIO.EXP";
  
  //Apertura del file ascii in lettura
  m_idFile=fopen(nFile,"r");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile leggere il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();
   result=fgets(dati,999,m_idFile);
   if(result==NULL)
    break;
   fit=(const char *)dati;
  
   pos=0;

	memAddr=fit.Mid(pos,1);pos+=1;
	nBit=fit.Mid(pos,1);pos+=1;
	type=fit.Mid(pos,1);pos+=1;
	des=fit.Mid(pos,15);pos+=15;
   
   Insert(
	 memAddr,
	 nBit,
	 type,
	 des
   );
  }
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}



long int CTabCfgIO::Count(CString filtro){
  CWaitCursor wait;
  long nrec=0L;
  int nOldFiled=m_nFields;
  m_nFields=1;

  CString qry;
  qry="SELECT COUNT(*) FROM CFGIO ";
  if(filtro!="")
   qry+=filtro;

  Open(CRecordset::dynamic,qry,CRecordset::none); //forwardOnly
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
  }else{
   
	nrec=atol(m_memAddr);

   Close();
  }

  m_nFields=nOldFiled;
  return nrec;
}

//Controlla se esiste il codice specificato, se esiste carica i dati
//nelle rispettive variabili
int CTabCfgIO::LoadDati(CString& memAddr,CString& nBit,CString& type){
  int sts=0;
  CString qry;
  qry="SELECT * FROM CFGIO WHERE memAddr='"+memAddr+"' and nBit='"+nBit+"' and type='"+type+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}

//Immissione dati
int CTabCfgIO::Insert(
	 CString& memAddr,
	 CString& nBit,
	 CString& type,
	 CString& des
 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM CFGIO WHERE memAddr='"+memAddr+"' and nBit='"+nBit+"' and type='"+type+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //ESISTE ?
   sts=RC_NO; 
   AddNew();
  }else{
   Edit();
   sts=RC_SI; 
  }

  //Assegno il valore ai vari campi
	m_memAddr=memAddr;
	m_nBit=nBit;
	m_type=type;
	m_des=des;
  
  //Gestione delle eccezioni
  try{
   Update(); 
  }catch( CDBException* e ){
   AfxMessageBox("Errore su Update (CFGIO)\n"+e->m_strError,MB_ICONEXCLAMATION );
   e->Delete();
  }
  Close();
  return(sts);
}

//Cancellazione Singolo Dato
int CTabCfgIO::DeleteRec(CString& memAddr,CString& nBit,CString& type){
  int sts=RC_SI;
  CString qry;
  qry="SELECT * FROM CFGIO WHERE memAddr='"+memAddr+"' and nBit='"+nBit+"' and type='"+type+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //esiste ?
   AfxMessageBox("Impossibile cancellare. Dato non presente!");
   sts=RC_NO;
  }else{
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Delete (CFGIO)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
  }
  Close();
  return(sts);
}

//Cancello tutti i dati 
int CTabCfgIO::DeleteAll(){
  long nrec=0L;
  Open(CRecordset::dynamic,"SELECT * FROM CFGIO ",CRecordset::none);
   if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   return RC_ERR;
  }

  //Conto il numero di record 
  while(!IsEOF()){
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su DeleteAll (CFGIO) \n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
   MoveNext(); //Vado sul record successivo
  }
  Close();
  return RC_SI;
}

//Inserisce i record nella listview
int CTabCfgIO::MakeList(CListCtrl *m_Listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro){

  LV_ITEM lvi;
  lvi.mask=LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
  lvi.iSubItem=0;

  CString clausola;
  int nrec=0;

  clausola="SELECT * FROM CFGIO ";
  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY memAddr,nBit,type"; break;
   default: clausola=clausola+" ORDER BY memAddr,nBit,type"; break;
  }
  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";
  
  Open(CRecordset::dynamic,clausola,CRecordset::none);

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   return 0;
  }

  //Inserisco dati dei singoli record
  m_Listview->DeleteAllItems();
  nrec=0;
  while(!IsEOF()){

   if(progBar!=NULL)
    progBar->StepIt();

   lvi.iItem=nrec; 
   lvi.pszText="";
   lvi.cchTextMax=5;
   lvi.lParam = (LPARAM) nrec; 
   lvi.iImage = 0; 
   m_Listview->InsertItem(&lvi);

	m_Listview->SetItemText(nrec,0,m_memAddr);
	m_Listview->SetItemText(nrec,1,m_nBit);
	m_Listview->SetItemText(nrec,2,m_type);
	m_Listview->SetItemText(nrec,3,m_des);

   nrec++;
   MoveNext();
  }
  Close();
  return nrec;
}


//Inserisce i record nella listview Virtuale
int CTabCfgIO::GetRecordForDispInfo(CListCtrl *m_FG,LVITEM* pItem){
	if(pItem->iSubItem == 0){ //Solo al cambio del record leggo 
		                      //dati dalla tabella
   MoveFirst();
   Move(pItem->iItem);
   if(!IsEOF()){
    //pItem->iImage = atoi(xxx); 
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_memAddr); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_nBit); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_type); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_des); break; 
    }
   }
  }else{
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_memAddr); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_nBit); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_type); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_des); break; 
    }
  }
  return 0;
}

//Imposta Recordset
int CTabCfgIO::OpenRecordSet(qtHead *m_inttab,CString filtro){
  CString clausola;
  clausola="SELECT * FROM CFGIO ";

  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY memAddr,nBit,type"; break;
   default: clausola=clausola+" ORDER BY memAddr,nBit,type"; break;
  }

  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";

  if(CanBookmark())
   Open(CRecordset::dynamic,clausola,CRecordset::useBookmarks);
  else
   Open(CRecordset::dynamic,clausola,CRecordset::none);  //useBookmarks

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGIO !");
   return RC_ERR; //Errore
  }
  return RC_SI;   //OK
}


/////////////////////////////////////////////////////////////////////////////
// CTabCfgIO Diagnostica

#ifdef _DEBUG
void CTabCfgIO::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTabCfgIO::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001
