////////////////////////////////////////////
// Programma:
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabSMTPSrv.cpp 
// Storia:
// Data Creazione: 10/06/2001
// (c) 2001 SofTech di Germinara Francesco
////////////////////////////////////////////

#include "stdafx.h"
#include "FGSms.h"
#include "CTabSMTPSrv.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CTabSMTPSrv, CRecordset)

CTabSMTPSrv::CTabSMTPSrv(CDatabase* pdb)
	: CRecordset(pdb)
{
    //Inizializzazione dei campi, del numero di campi
	//e del tipo di gestione del database
	m_SrvName= _T("");
	m_DomainName= _T("");

	m_nFields = 2;

	m_nDefaultType = dynamic; //dynaset
	m_pDB=pdb; //Assegno il puntatore al database aperto
	
	//Lunghezze dei campi della tabella
	m_len_SrvName= 100;
	m_len_DomainName= 100;
}

//Connessione con il database
CString CTabSMTPSrv::GetDefaultConnect()
{
 //Apre la connessione stabilita con il database
 return _T(m_pDB->GetConnect());
}

//Connessione con la tabella
CString CTabSMTPSrv::GetDefaultSQL()
{
 //Nessuna operazione iniziale
 return _T("");
}

//Funzione per interscambio dati da/verso tabella del DB
void CTabSMTPSrv::DoFieldExchange(CFieldExchange* pFX)
{
   	pFX->SetFieldType(CFieldExchange::outputColumn);
	 RFX_Text(pFX, _T("[SrvName]"),m_SrvName);
	if(m_nFields>1){
	 RFX_Text(pFX, _T("[DomainName]"),m_DomainName);
	}
}

//ESPORTA IN FILE ASCII
void CTabSMTPSrv::Export(CProgressCtrl *progBar=NULL){
  long nrec=0L;
  CString fit;

  //Definizione dei nomi dei files
  CString nFile,msg;
  char dati[1001];
  FILE *m_idFile;
  bool FileIsOpen;
  nFile=theApp.bseInfo.m_strPathExp;
  nFile+="CFGSMTP.EXP";

  Open(CRecordset::dynamic,"SELECT * FROM CFGSMTP ",CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   return;
  }
  //Apertura del file ascii
  m_idFile=fopen(nFile,"w+");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile generare il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(!IsEOF()&&FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();

	fit.Format("%100s",m_SrvName);strcpy(dati,fit);
	fit.Format("%100s",m_DomainName);strcat(dati,fit);
   
   fputs(dati,m_idFile);
   fputs("\n",m_idFile);
   MoveNext();
  }
  Close();
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}

//IMPORTA IL FILE ASCII
void CTabSMTPSrv::Import(CProgressCtrl *progBar){
  long nrec=0L;
  CString fit;
  
  //Definizione dei nomi dei files
  CString nFile,msg;
	CString SrvName;
	CString DomainName;

  char dati[1001];
  char *result;
  FILE *m_idFile;
  bool FileIsOpen;
  int pos=0;
  nFile=theApp.bseInfo.m_strPathImp;
  nFile+="CFGSMTP.EXP";
  
  //Apertura del file ascii in lettura
  m_idFile=fopen(nFile,"r");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile leggere il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();
   result=fgets(dati,999,m_idFile);
   if(result==NULL)
    break;
   fit=(const char *)dati;
  
   pos=0;

	SrvName=fit.Mid(pos,100);pos+=100;
	DomainName=fit.Mid(pos,100);pos+=100;
   
   Insert(
	 SrvName,
	 DomainName
   );
  }
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}



long int CTabSMTPSrv::Count(CString filtro){
  CWaitCursor wait;
  long nrec=0L;
  int nOldFiled=m_nFields;
  m_nFields=1;

  CString qry;
  qry="SELECT COUNT(*) FROM CFGSMTP ";
  if(filtro!="")
   qry+=filtro;

  Open(CRecordset::dynamic,qry,CRecordset::none); //forwardOnly
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
  }else{
   
	nrec=atol(m_SrvName);

   Close();
  }

  m_nFields=nOldFiled;
  return nrec;
}

//Controlla se esiste il codice specificato, se esiste carica i dati
//nelle rispettive variabili
int CTabSMTPSrv::LoadDati(CString& SrvName){
  int sts=0;
  CString qry;
  qry="SELECT * FROM CFGSMTP WHERE SrvName='"+SrvName+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}

//Immissione dati
int CTabSMTPSrv::Insert(
	 CString& SrvName,
	 CString& DomainName
 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM CFGSMTP WHERE SrvName='"+SrvName+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //ESISTE ?
   sts=RC_NO; 
   AddNew();
  }else{
   Edit();
   sts=RC_SI; 
  }

  //Assegno il valore ai vari campi
	m_SrvName=SrvName;
	m_DomainName=DomainName;
  
  //Gestione delle eccezioni
  try{
   Update(); 
  }catch( CDBException* e ){
   AfxMessageBox("Errore su Update (CFGSMTP)\n"+e->m_strError,MB_ICONEXCLAMATION );
   e->Delete();
  }
  Close();
  return(sts);
}

//Cancellazione Singolo Dato
int CTabSMTPSrv::DeleteRec(CString& SrvName){
  int sts=RC_SI;
  CString qry;
  qry="SELECT * FROM CFGSMTP WHERE SrvName='"+SrvName+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //esiste ?
   AfxMessageBox("Impossibile cancellare. Dato non presente!");
   sts=RC_NO;
  }else{
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Delete (CFGSMTP)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
  }
  Close();
  return(sts);
}

//Cancello tutti i dati 
int CTabSMTPSrv::DeleteAll(){
  long nrec=0L;
  Open(CRecordset::dynamic,"SELECT * FROM CFGSMTP ",CRecordset::none);
   if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   return RC_ERR;
  }

  //Conto il numero di record 
  while(!IsEOF()){
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su DeleteAll (CFGSMTP) \n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
   MoveNext(); //Vado sul record successivo
  }
  Close();
  return RC_SI;
}

//Inserisce i record nella listview
int CTabSMTPSrv::MakeList(CListCtrl *m_Listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro){

  LV_ITEM lvi;
  lvi.mask=LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
  lvi.iSubItem=0;

  CString clausola;
  int nrec=0;

  clausola="SELECT * FROM CFGSMTP ";
  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY SrvName"; break;
   default: clausola=clausola+" ORDER BY SrvName"; break;
  }
  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";
  
  Open(CRecordset::dynamic,clausola,CRecordset::none);

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   return 0;
  }

  //Inserisco dati dei singoli record
  m_Listview->DeleteAllItems();
  nrec=0;
  while(!IsEOF()){

   if(progBar!=NULL)
    progBar->StepIt();

   lvi.iItem=nrec; 
   lvi.pszText="";
   lvi.cchTextMax=5;
   lvi.lParam = (LPARAM) nrec; 
   lvi.iImage = 0; 
   m_Listview->InsertItem(&lvi);

   m_DomainName.TrimRight();
   m_SrvName.TrimRight();

   m_Listview->SetItemText(nrec,0,m_SrvName);
   m_Listview->SetItemText(nrec,1,m_DomainName);

   nrec++;
   MoveNext();
  }
  Close();
  return nrec;
}


//Inserisce i record nella listview Virtuale
int CTabSMTPSrv::GetRecordForDispInfo(CListCtrl *m_FG,LVITEM* pItem){
	if(pItem->iSubItem == 0){ //Solo al cambio del record leggo 
		                      //dati dalla tabella
   MoveFirst();
   Move(pItem->iItem);
   if(!IsEOF()){
    //pItem->iImage = atoi(xxx); 
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_SrvName); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_DomainName); break; 
    }
   }
  }else{
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_SrvName); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_DomainName); break; 
    }
  }
  return 0;
}

//Imposta Recordset
int CTabSMTPSrv::OpenRecordSet(qtHead *m_inttab,CString filtro){
  CString clausola;
  clausola="SELECT * FROM CFGSMTP ";

  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY SrvName"; break;
   default: clausola=clausola+" ORDER BY SrvName"; break;
  }

  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";

  if(CanBookmark())
   Open(CRecordset::dynamic,clausola,CRecordset::useBookmarks);
  else
   Open(CRecordset::dynamic,clausola,CRecordset::none);  //useBookmarks

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   return RC_ERR; //Errore
  }
  return RC_SI;   //OK
}


/////////////////////////////////////////////////////////////////////////////
// CTabSMTPSrv Diagnostica

#ifdef _DEBUG
void CTabSMTPSrv::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTabSMTPSrv::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001


int CTabSMTPSrv::SearchSrvName(CString& DomainName){
  int sts=0;
  CString qry;
  qry="SELECT * FROM CFGSMTP WHERE DomainName='"+DomainName+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGSMTP !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}
