////////////////////////////////////////////
// Programma:
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabStoricoMsg.cpp 
// Storia:
// Data Creazione: 28/11/2001
// (c) 2001 SofTech di Germinara Francesco
////////////////////////////////////////////

#include "stdafx.h"
#include "FGSms.h"
#include "CTabStoricoMsg.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CTabStoricoMsg, CRecordset)

CTabStoricoMsg::CTabStoricoMsg(CDatabase* pdb)
	: CRecordset(pdb)
{
    //Inizializzazione dei campi, del numero di campi
	//e del tipo di gestione del database
	m_idMSG= _T("");
	m_textMSG= _T("");
	m_flgSts= _T("");
	m_nTelef= _T("");
	m_data= _T("");
	m_ora= _T("");
	m_idUser= _T("");

	m_nFields = 7;

	m_nDefaultType = dynamic; //dynaset
	m_pDB=pdb; //Assegno il puntatore al database aperto
	
	//Lunghezze dei campi della tabella
	m_len_idMSG= 10;
	m_len_textMSG= 160;
	m_len_flgSts= 1;
	m_len_nTelef= 50;
	m_len_data= 8;
	m_len_ora= 8;
	m_len_idUser= 10;
}

//Connessione con il database
CString CTabStoricoMsg::GetDefaultConnect()
{
 //Apre la connessione stabilita con il database
 return _T(m_pDB->GetConnect());
}

//Connessione con la tabella
CString CTabStoricoMsg::GetDefaultSQL()
{
 //Nessuna operazione iniziale
 return _T("");
}

//Funzione per interscambio dati da/verso tabella del DB
void CTabStoricoMsg::DoFieldExchange(CFieldExchange* pFX)
{
   	pFX->SetFieldType(CFieldExchange::outputColumn);
	 RFX_Text(pFX, _T("[idMSG]"),m_idMSG);
	if(m_nFields>1){
	 RFX_Text(pFX, _T("[textMSG]"),m_textMSG);
	 RFX_Text(pFX, _T("[flgSts]"),m_flgSts);
	 RFX_Text(pFX, _T("[nTelef]"),m_nTelef);
	 RFX_Text(pFX, _T("[data]"),m_data);
	 RFX_Text(pFX, _T("[ora]"),m_ora);
	 RFX_Text(pFX, _T("[idUser]"),m_idUser);
	}
}

//ESPORTA IN FILE ASCII
void CTabStoricoMsg::Export(CProgressCtrl *progBar=NULL){
  long nrec=0L;
  CString fit;

  //Definizione dei nomi dei files
  CString nFile,msg;
  char dati[1001];
  FILE *m_idFile;
  bool FileIsOpen;
  nFile=theApp.bseInfo.m_strPathExp;
  nFile+="StoricoM.EXP";

  Open(CRecordset::dynamic,"SELECT * FROM StoricoMsg ",CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   return;
  }
  //Apertura del file ascii
  m_idFile=fopen(nFile,"w+");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile generare il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(!IsEOF()&&FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();

	fit.Format("%10s",m_idMSG);strcpy(dati,fit);
	fit.Format("%160s",m_textMSG);strcat(dati,fit);
	fit.Format("%1s",m_flgSts);strcat(dati,fit);
	fit.Format("%50s",m_nTelef);strcat(dati,fit);
	fit.Format("%8s",m_data);strcat(dati,fit);
	fit.Format("%8s",m_ora);strcat(dati,fit);
	fit.Format("%10s",m_idUser);strcat(dati,fit);
   
   fputs(dati,m_idFile);
   fputs("\n",m_idFile);
   MoveNext();
  }
  Close();
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}

//IMPORTA IL FILE ASCII
void CTabStoricoMsg::Import(CProgressCtrl *progBar){
  long nrec=0L;
  CString fit;
  
  //Definizione dei nomi dei files
  CString nFile,msg;
	CString idMSG;
	CString textMSG;
	CString flgSts;
	CString nTelef;
	CString data;
	CString ora;
	CString idUser;

  char dati[1001];
  char *result;
  FILE *m_idFile;
  bool FileIsOpen;
  int pos=0;
  nFile=theApp.bseInfo.m_strPathImp;
  nFile+="StoricoM.EXP";
  
  //Apertura del file ascii in lettura
  m_idFile=fopen(nFile,"r");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile leggere il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();
   result=fgets(dati,999,m_idFile);
   if(result==NULL)
    break;
   fit=(const char *)dati;
  
   pos=0;

	idMSG=fit.Mid(pos,10);pos+=10;
	textMSG=fit.Mid(pos,160);pos+=160;
	flgSts=fit.Mid(pos,1);pos+=1;
	nTelef=fit.Mid(pos,50);pos+=50;
	data=fit.Mid(pos,8);pos+=8;
	ora=fit.Mid(pos,8);pos+=8;
	idUser=fit.Mid(pos,10);pos+=10;
   
   Insert(
	 idMSG,
	 textMSG,
	 flgSts,
	 nTelef,
	 data,
	 ora,
	 idUser
   );
  }
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}



long int CTabStoricoMsg::Count(CString filtro){
  CWaitCursor wait;
  long nrec=0L;
  int nOldFiled=m_nFields;
  m_nFields=1;

  CString qry;
  qry="SELECT COUNT(*) FROM StoricoMsg ";
  if(filtro!="")
   qry+=filtro;

  Open(CRecordset::dynamic,qry,CRecordset::none); //forwardOnly
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
  }else{
   
	nrec=atol(m_idMSG);

   Close();
  }

  m_nFields=nOldFiled;
  return nrec;
}

//Controlla se esiste il codice specificato, se esiste carica i dati
//nelle rispettive variabili
int CTabStoricoMsg::LoadDati(CString& idMSG,CString& nTelef,CString& data,CString& ora){
  int sts=0;
  CString qry;
  qry="SELECT * FROM StoricoMsg WHERE idMSG='"+idMSG+"' and nTelef='"+nTelef+"' and data='"+data+"' and ora='"+ora+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}

//Immissione dati
int CTabStoricoMsg::Insert(
	 CString& idMSG,
	 CString& textMSG,
	 CString& flgSts,
	 CString& nTelef,
	 CString& data,
	 CString& ora,
	 CString& idUser
 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM StoricoMsg WHERE idMSG='"+idMSG+"' and nTelef='"+nTelef+"' and data='"+data+"' and ora='"+ora+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //ESISTE ?
   sts=RC_NO; 
   AddNew();
  }else{
   Edit();
   sts=RC_SI; 
  }

  //Assegno il valore ai vari campi
	m_idMSG=idMSG;
	m_textMSG=textMSG;
	m_flgSts=flgSts;
	m_nTelef=nTelef;
	m_data=data;
	m_ora=ora;
	m_idUser=idUser;
  
  //Gestione delle eccezioni
  try{
   Update(); 
  }catch( CDBException* e ){
   AfxMessageBox("Errore su Update (StoricoMsg)\n"+e->m_strError,MB_ICONEXCLAMATION );
   e->Delete();
  }
  Close();
  return(sts);
}

//Cancellazione Singolo Dato
int CTabStoricoMsg::DeleteRec(CString& idMSG,CString& nTelef,CString& data,CString& ora){
  int sts=RC_SI;
  CString qry;
  qry="SELECT * FROM StoricoMsg WHERE idMSG='"+idMSG+"' and nTelef='"+nTelef+"' and data='"+data+"' and ora='"+ora+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //esiste ?
   AfxMessageBox("Impossibile cancellare. Dato non presente!");
   sts=RC_NO;
  }else{
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Delete (StoricoMsg)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
  }
  Close();
  return(sts);
}

//Cancello tutti i dati 
int CTabStoricoMsg::DeleteAll(){
  long nrec=0L;
  Open(CRecordset::dynamic,"SELECT * FROM StoricoMsg ",CRecordset::none);
   if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   return RC_ERR;
  }

  //Conto il numero di record 
  while(!IsEOF()){
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su DeleteAll (StoricoMsg) \n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
   MoveNext(); //Vado sul record successivo
  }
  Close();
  return RC_SI;
}

//Inserisce i record nella listview
int CTabStoricoMsg::MakeList(CListCtrl *m_Listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro){

  LV_ITEM lvi;
  lvi.mask=LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
  lvi.iSubItem=0;

  CString clausola;
  int nrec=0;

  clausola="SELECT * FROM StoricoMsg ";
  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY idMSG,nTelef,data,ora"; break;
   default: clausola=clausola+" ORDER BY idMSG,nTelef,data,ora"; break;
  }
  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";
  
  Open(CRecordset::dynamic,clausola,CRecordset::none);

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   return 0;
  }

  //Inserisco dati dei singoli record
  m_Listview->DeleteAllItems();
  nrec=0;
  while(!IsEOF()){

   if(progBar!=NULL)
    progBar->StepIt();

   lvi.iItem=nrec; 
   lvi.pszText="";
   lvi.cchTextMax=5;
   lvi.lParam = (LPARAM) nrec; 
   lvi.iImage = 0; 
   m_Listview->InsertItem(&lvi);

	m_Listview->SetItemText(nrec,0,m_idMSG);
	m_Listview->SetItemText(nrec,1,m_textMSG);
	m_Listview->SetItemText(nrec,2,m_flgSts);
	m_Listview->SetItemText(nrec,3,m_nTelef);
	m_Listview->SetItemText(nrec,4,m_data);
	m_Listview->SetItemText(nrec,5,m_ora);
	m_Listview->SetItemText(nrec,6,m_idUser);

   nrec++;
   MoveNext();
  }
  Close();
  return nrec;
}


//Inserisce i record nella listview Virtuale
int CTabStoricoMsg::GetRecordForDispInfo(CListCtrl *m_FG,LVITEM* pItem){
	if(pItem->iSubItem == 0){ //Solo al cambio del record leggo 
		                      //dati dalla tabella
   MoveFirst();
   Move(pItem->iItem);
   if(!IsEOF()){
    //pItem->iImage = atoi(xxx); 
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_idMSG); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_textMSG); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_flgSts); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_nTelef); break; 
	case 4: lstrcpy(pItem->pszText, (LPCTSTR) m_data); break; 
	case 5: lstrcpy(pItem->pszText, (LPCTSTR) m_ora); break; 
	case 6: lstrcpy(pItem->pszText, (LPCTSTR) m_idUser); break; 
    }
   }
  }else{
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_idMSG); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_textMSG); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_flgSts); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_nTelef); break; 
	case 4: lstrcpy(pItem->pszText, (LPCTSTR) m_data); break; 
	case 5: lstrcpy(pItem->pszText, (LPCTSTR) m_ora); break; 
	case 6: lstrcpy(pItem->pszText, (LPCTSTR) m_idUser); break; 
    }
  }
  return 0;
}

//Imposta Recordset
int CTabStoricoMsg::OpenRecordSet(qtHead *m_inttab,CString filtro){
  CString clausola;
  clausola="SELECT * FROM StoricoMsg ";

  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY idMSG,nTelef,data,ora"; break;
   default: clausola=clausola+" ORDER BY idMSG,nTelef,data,ora"; break;
  }

  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";

  if(CanBookmark())
   Open(CRecordset::dynamic,clausola,CRecordset::useBookmarks);
  else
   Open(CRecordset::dynamic,clausola,CRecordset::none);  //useBookmarks

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella StoricoMsg !");
   return RC_ERR; //Errore
  }
  return RC_SI;   //OK
}


/////////////////////////////////////////////////////////////////////////////
// CTabStoricoMsg Diagnostica

#ifdef _DEBUG
void CTabStoricoMsg::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTabStoricoMsg::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001
