// FGSms.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "FGSms.h"
#include "FGSmsDlg.h"
#include "CCmdLineParms.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFGSmsApp

BEGIN_MESSAGE_MAP(CFGSmsApp, CWinApp)
	//{{AFX_MSG_MAP(CFGSmsApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFGSmsApp construction

CFGSmsApp::CFGSmsApp()
{
 m_bConfigurationEnable=FALSE; 
 m_strWorkDir="C:\\";
 m_strMemSharedName="MEMFGSMS";
 m_strTmPolling="60";

 m_nConnectionType=0;
 m_nDataBits=0;
 m_nParityType=2;
 m_nSerialPort=0;
 m_nStopBits=0;
 m_nBaudRate=7;
 m_nParallelPort=0;
 m_bEnableLogs=FALSE;
 m_bUseParallelPort=TRUE;
 m_bUseIOcard=FALSE;

 m_strNCentroServizi="+393492000300";
 m_strConfigurationEnable="0";
 m_strConnectionType="0";
 m_strDataBits="0";
 m_strParityType="2";
 m_strSerialPort="0";
 m_strStopBits="0";
 m_strBaudRate="7";
 m_strSmtpSvr="mail.germinara.it";
 m_strParityMode="M";
 m_PassWordCfg="FGSMS";
 m_strEnableLogs="0";
 m_strUseParallelPort="1";
 m_strParallelPortNum="0";
 m_strUseIOcard="0";


//MAIL
	m_strDisplayName="";
	m_strMittente = ""; 
	m_strDestinatario="";
	m_strMsg = "";
	m_strSubject ="";
	m_strSMTPsrv="";
	m_strPOPsrv="";
    m_nPort=25; //SMTP Standard Port

	//Per la lettura della posta...
	m_strPassWord="";
	m_strUserConn="";

	//SMTP per invio della posta...
	m_strSMTPsrv = m_strSMTPsrv;
    m_bAutoDial=TRUE;
    m_sBoundIP=""; //ANY 
	m_Authenticate=CSMTPConnection::NoLoginMethod; //NoLoginMethod; //Nessuna Autenticazione
    m_sEncodingFriendly=_T("Western European (ISO)");
    m_sEncodingCharset=_T("iso-8859-1");
    m_sEncodingFriendly=_T("");
    m_sEncodingCharset=_T("");
    m_bMime=TRUE;
    m_bHTML=FALSE;
	m_sUsername=""; 
	m_sPassword="";

	if (!AfxSocketInit()){
     AfxMessageBox("Failed to initialise the Winsock stack!");
	}
 
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFGSmsApp object

CFGSmsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFGSmsApp initialization

BOOL CFGSmsApp::InitInstance()
{
  int rc=0;
  m_bOkStarted=FALSE;
  AfxEnableControlContainer();

  CString fit;
  //Set application register keypath
  SetRegistryKey(_T(bseInfo.m_strRegKey1+"\\"+bseInfo.m_strRegKey2+"\\"+bseInfo.m_strRegKey3));

  LoadStdProfileSettings(5);  // Load standard INI file options (including MRU)
  if(bseInfo.GetRegEdit()==FALSE) //Load value specified in the registry
   bseInfo.SetRegEdit(); //If not found, set default value for registry options

  CCmdLineParms cmdInfo;
  ParseCommandLine(cmdInfo);

  if(m_idSession!="001" && m_idSession!= "002"){
   AfxMessageBox("Errore: Indicare l'ID della Sessione (001 o 002).");
   return FALSE;
  }

 rc=m_DB.OpenDB(); //Open the application database
 if(rc==FALSE)     //Error, probably there isn't the ODBC connection.
  return FALSE;

 m_DB.SetQueryTimeout(5*60); //Set query timeout to five minutes.

	//Create table object
	m_pTabCfgFgSms = new CTabCfgFgSms(&m_DB);
	m_pTabSMTPSrv  = new CTabSMTPSrv(&m_DB);
    m_pTabGroup    = new CTabGroup(&m_DB);
	m_pTabUser     = new CTabUser(&m_DB);
	m_pTabCfgIO    = new CTabCfgIO(&m_DB);
	m_pTabStoricoMsg = new CTabStoricoMsg(&m_DB);
	m_pTabUserCopy     = new CTabUser(&m_DB);

	m_GsmAtCommands.SetupCommands(); //Set internal data for commands supported

	LoadConfig(); //Load initial settings

	m_bOkStarted=TRUE;

	//Check parallel port status...
	m_nParallelPort=0;
	m_naLptAddr[0]=-1;
	m_naLptAddr[1]=-1;
	m_naLptAddr[2]=-1;
	if((m_bUseParallelPort &  0x01) == 0x01) //LPT1 have fgHwSMS
     m_naLptAddr[0]=theApp.m_fgHwSms.GetBsePortAddr(0);
	if((m_bUseParallelPort &  0x02) == 0x02) //LPT2 have fgHwSMS
     m_naLptAddr[1]=theApp.m_fgHwSms.GetBsePortAddr(1);
	if((m_bUseParallelPort &  0x04) == 0x04) //LPT3 have fgHwSMS
     m_naLptAddr[2]=theApp.m_fgHwSms.GetBsePortAddr(2);

    for(int i=0;i<3;i++)
	 if(m_naLptAddr[i]>0)
	  m_nParallelPort++;

	//Set information on lpts connection....and set all OUTPUT  lines to 0

	msgParStatus="";
	CString fitSts;
	fitSts="";
	if(m_naLptAddr[0]>0)  fitSts.Format("%0x ",m_naLptAddr[0]);
	if(m_naLptAddr[0]==0) fitSts ="#N/A ";
	if(fitSts.GetLength()){
	 msgParStatus+="Lpt1: "+fitSts;
	 theApp.m_fgHwSms.WriteDataOUT(m_naLptAddr[0],0x0);
	}

	fitSts="";
	if(m_naLptAddr[1]>0)  fitSts.Format("%0x ",m_naLptAddr[1]);
	if(m_naLptAddr[1]==0) fitSts ="#N/A ";
	if(fitSts.GetLength()){
	 msgParStatus+="Lpt2: "+fitSts;
	 theApp.m_fgHwSms.WriteDataOUT(m_naLptAddr[1],0x0);
	}
	
	fitSts="";
	if(m_naLptAddr[2]>0)  fitSts.Format("%0x ",m_naLptAddr[2]);
	if(m_naLptAddr[2]==0) fitSts =="#N/A ";
	if(fitSts.GetLength()){
	 msgParStatus+="Lpt3: "+fitSts;
	 theApp.m_fgHwSms.WriteDataOUT(m_naLptAddr[2],0x0);
	}
	
	//msgParStatus.Format("\nLPT1: Addr: %x \nLPT2: Addr: %x \nLPT3: Addr: %x Total Port OK: %d",m_naLptAddr[0],m_naLptAddr[1],m_naLptAddr[2],m_nParallelPort);
	//AfxMessageBox(msgParStatus);

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

 theApp.m_bseDataStart.Oggi();

	CFGSmsDlg dlg;
	m_pMainWnd = &dlg;
	dlg.m_strStsLpts=msgParStatus;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

//Load settings
/* OLD VERSION
BOOL CFGSmsApp::LoadConfig(){
 CFile f;
 CFileException ex;
 char buf[512];
 int sts=0;

 CString strNameF("FGSMS.CFG");

 sts=f.Open(strNameF, CFile::modeRead|CFile::typeBinary,&ex);
 if(!sts){
  //if(ex.m_cause == CFileException::fileNotFound)
  // AfxMessageBox("Impossibile trovare il file "+ strNameF);
  return FALSE;
 }
 CArchive ar(&f, CArchive::load, 512, buf );
 DWORD wTemp;
 ar >> wTemp; m_bConfigurationEnable = (BOOL) wTemp;
 ar >> m_strWorkDir;
 ar >> m_strMemSharedName;
 ar >> m_strTmPolling;

 ar >> m_nConnectionType;
 ar >> m_nDataBits;
 ar >> m_nParityType;
 ar >> m_nSerialPort;
 ar >> m_nStopBits;
 ar >> m_nBaudRate;

 ar >> m_strNCentroServizi;

 ar.Close();
 f.Close();
 return TRUE;
}
*/
//Load settings
BOOL CFGSmsApp::LoadConfig(){
   int sts=0;
   sts=theApp.m_pTabCfgFgSms->LoadDati(theApp.m_idSession);
   if(sts==RC_SI){ //Ok, found ... 
	m_strSmtpSvr=theApp.m_pTabCfgFgSms->m_SmtpSvr;
	m_strSerialPort=theApp.m_pTabCfgFgSms->m_ComPort;
	m_strBaudRate=theApp.m_pTabCfgFgSms->m_BaudRate;
	m_strDataBits=theApp.m_pTabCfgFgSms->m_DataBit;
	m_strStopBits=theApp.m_pTabCfgFgSms->m_StopBit;
	m_strParityType=theApp.m_pTabCfgFgSms->m_Parity;
	m_strParityMode=theApp.m_pTabCfgFgSms->m_TypeParity;
	m_strConnectionType=theApp.m_pTabCfgFgSms->m_Mode;

	m_strNCentroServizi=theApp.m_pTabCfgFgSms->m_SMSCNumber;
	m_strTmPolling=theApp.m_pTabCfgFgSms->m_PollingTime;
	m_strWorkDir=theApp.m_pTabCfgFgSms->m_DirLogFiles;
	m_strMemSharedName=theApp.m_pTabCfgFgSms->m_NameSharedMem;

	m_PassWordCfg=theApp.m_pTabCfgFgSms->m_PassWordCfg;

	m_strConfigurationEnable=theApp.m_pTabCfgFgSms->m_CfgMode;

	m_strEnableLogs=theApp.m_pTabCfgFgSms->m_EnableLogs;
	m_strUseParallelPort=theApp.m_pTabCfgFgSms->m_UseParallelPort;
	m_strParallelPortNum=theApp.m_pTabCfgFgSms->m_ParallelPortNum;
	m_strUseIOcard=theApp.m_pTabCfgFgSms->m_UseIOcard;
    //Trim right blanks
	m_strSmtpSvr.TrimRight();
	m_strNCentroServizi.TrimRight();
	m_strTmPolling.TrimRight();
	m_strWorkDir.TrimRight();
	m_strMemSharedName.TrimRight();
	m_PassWordCfg.TrimRight();
   }
   m_nConnectionType=atoi(m_strConnectionType);
   m_nDataBits=atoi(m_strDataBits);
   m_nParityType=atoi(m_strParityType);
   m_nSerialPort=atoi(m_strSerialPort);
   m_nStopBits=atoi(m_strStopBits);
   m_nBaudRate=atoi(m_strBaudRate);
   m_nParallelPort=atoi(m_strParallelPortNum);
   m_bEnableLogs=atoi(m_strEnableLogs);
   m_bUseParallelPort=atoi(m_strUseParallelPort);
   m_bUseIOcard=atoi(m_strUseIOcard);
   m_bConfigurationEnable=atoi(m_strConfigurationEnable);
   return sts;
}


//Save settings
/*old version
BOOL CFGSmsApp::SaveConfig(){
 CFile f;
 CFileException ex;
 char buf[512];
 int sts=0;

 CString strNameF("FGSMS.CFG");

 sts=f.Open(strNameF, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary,&ex);
 if(!sts){
  //if(ex.m_cause == CFileException::fileNotFound)
  AfxMessageBox("Impossibile salvare configurazione sul file "+ strNameF);
  return FALSE;
 }
 CArchive ar(&f, CArchive::store, 512, buf );

 ar << (DWORD) m_bConfigurationEnable;
 ar << m_strWorkDir;
 ar << m_strMemSharedName;
 ar << m_strTmPolling;

 ar << m_nConnectionType;
 ar << m_nDataBits;
 ar << m_nParityType;
 ar << m_nSerialPort;
 ar << m_nStopBits;
 ar << m_nBaudRate;

 ar << m_strNCentroServizi;

 ar.Close();
 f.Close();
 return TRUE;
}
*/

//Save settings
BOOL CFGSmsApp::SaveConfig(){
   int sts=0;

   m_strConnectionType.Format("%1d",m_nConnectionType);
   m_strDataBits.Format("%1d",m_nDataBits);
   m_strParityType.Format("%1d",m_nParityType);
   m_strSerialPort.Format("%1d",m_nSerialPort);
   m_strStopBits.Format("%1d",m_nStopBits);
   m_strBaudRate.Format("%1d",m_nBaudRate);
   m_strParallelPortNum.Format("%1d",m_nParallelPort);
   m_strEnableLogs.Format("%1d",m_bEnableLogs);
   m_strUseParallelPort.Format("%1d",m_bUseParallelPort);
   m_strUseIOcard.Format("%1d",m_bUseIOcard);
   m_strConfigurationEnable.Format("%1d",m_bConfigurationEnable);

   sts=theApp.m_pTabCfgFgSms->Insert(
	 theApp.m_idSession,
	 m_strSmtpSvr,
	 m_strSerialPort,
	 m_strBaudRate,
	 m_strDataBits,
	 m_strStopBits,
	 m_strParityType,
	 m_strParityMode,
	 m_strConnectionType,
	 m_strNCentroServizi,
	 m_strTmPolling,
	 m_strWorkDir,
	 m_strMemSharedName,
	 m_PassWordCfg,
	 m_strConfigurationEnable,
	 m_strEnableLogs,
	 m_strUseParallelPort,
	 m_strParallelPortNum,
	 m_strUseIOcard
   );
   return sts;

}


int CFGSmsApp::ExitInstance() 
{

 if(m_bOkStarted){
  SaveConfig();

  //Destroy table object
  if(m_pTabCfgFgSms!=NULL)
   delete m_pTabCfgFgSms;

  if(m_pTabSMTPSrv!=NULL)
   delete m_pTabSMTPSrv;

  if(m_pTabGroup!=NULL)
   delete m_pTabGroup;

  if(m_pTabUser!=NULL)
   delete m_pTabUser;

  if(m_pTabCfgIO!=NULL)
   delete m_pTabCfgIO;
 
  if(m_pTabStoricoMsg!=NULL)
   delete m_pTabStoricoMsg;

  if(m_pTabUserCopy!=NULL)
   delete m_pTabUserCopy;


  //If database was open, close it
  if (m_DB.IsOpen())
   m_DB.Close();	

 }

 return CWinApp::ExitInstance();
}

void CFGSmsApp::CheckError(){
//-Passare id chiamante, e descr mot. errore, quindi reg. su log errori...

 DWORD dwLastError=0;
 LPVOID lpMsgBuf=NULL;
 //per test...
 dwLastError = GetLastError();
 if(dwLastError != 0) {
  FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,NULL,dwLastError,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR) &lpMsgBuf,0,NULL );
  AfxMessageBox( (LPCTSTR)lpMsgBuf);
  LocalFree( lpMsgBuf );
 }
}

CSMTPMessage* CFGSmsApp::CreateMessage()
{
 //Create the message
 CSMTPMessage* pMessage = new CSMTPMessage;
 CSMTPBodyPart attachment;

 //Set the mime flag
 pMessage->SetMime(m_bMime);

 //Set the charset of the message and all attachments
 pMessage->SetCharset(m_sEncodingCharset);
 attachment.SetCharset(m_sEncodingCharset);

 //Setup the all the recipient types for this message
 pMessage->AddMultipleRecipients(m_strDestinatario, CSMTPMessage::TO);
 m_strSubject.TrimRight();
 if(!m_strSubject.IsEmpty()) 
  pMessage->m_sSubject = m_strSubject;
 m_strMsg.TrimRight();
 if(!m_strMsg.IsEmpty())
  pMessage->AddTextBody(m_strMsg);
 //Add the attachment(s) if necessary
 m_strAttach.TrimRight();
 if(!m_strAttach.IsEmpty()) 
  pMessage->AddMultipleAttachments(m_strAttach);		
 //Setup the from address
 m_strDisplayName.TrimRight();
 if(m_strDisplayName.IsEmpty()) 
  {
		pMessage->m_From = m_strMittente;
		pMessage->m_ReplyTo = m_strMittente;
	}
	else 
  {
    CSMTPAddress address(m_strDisplayName, m_strMittente);
		pMessage->m_From = m_strMittente;
		pMessage->m_ReplyTo = m_strMittente;
	}

  pMessage->AddCustomHeader(m_strDenomForn);

  return pMessage;
}



/*
void CDlgEmail::OnBtnSend() 
{
 UpdateData(TRUE);

 m_strAttach.TrimRight();
 m_strSubject.TrimRight();
 m_strMsg.TrimRight();
 m_strDisplayName.TrimRight();
 m_strMittente.TrimRight();
 m_strDenomForn.TrimRight();
 m_strDestinatario.TrimRight();
 m_strSMTPsrv.TrimRight();

 if(m_strSMTPsrv.IsEmpty()){
  MessageBox("Errore di configurazione! Manca l'indirizzo del SERVER SMTP!");	  
  return;
 }

 if(m_strMittente.IsEmpty()){
  MessageBox("Errore: Occorre sempre indicare l'indirizzo di posta del mittente!");	  
  return;
 }
 if(m_strDestinatario.IsEmpty()){
  MessageBox("Errore: Occorre sempre indicare l'indirizzo di posta del destinatario!");	  
  return;
 }

 CWaitCursor wc;
 m_strInfo="Tento di connettermi...";
 UpdateData(FALSE);
 CSMTPMessage* pMessage = CreateMessage();
 CSMTPConnection connection;
 if(m_bAutoDial)
  connection.ConnectToInternet();
 BOOL bConnect = connection.Connect(m_strSMTPsrv, m_Authenticate, m_sUsername, m_sPassword, m_nPort, m_sBoundIP);
 if(!bConnect){
  m_strInfo.Format(_T("Connessione con server fallita!, Error:%d"), GetLastError());
  UpdateData(FALSE);

  //Tidy up the heap memory
  delete pMessage;
  return;

 }else{
  m_strInfo="OK, Invio messaggio in corso...";
  UpdateData(FALSE);
  //Send the message
  if(!connection.SendMessage(*pMessage)){
   m_strInfo.Format(_T("Impossibile inviare messaggio!\nRisposta:%s"), connection.GetLastCommandResponse());
   UpdateData(FALSE);

   if(m_bAutoDial)
    connection.CloseInternetConnection();
   //Tidy up the heap memory
   delete pMessage;
   return;
  }
 }
 if(m_bAutoDial)
  connection.CloseInternetConnection();

 //Tidy up the heap memory
 delete pMessage;
 m_strInfo="OK, messaggio inviato correttamente.";
 UpdateData(FALSE);
}

void CDlgEmail::OnBTNCHKMAIl() 
{
 UpdateData(TRUE);
 //controllo se c'e' posta
 CPop3Connection p3;
 m_strInfo="Tento di connettermi...";
 UpdateData(FALSE);
 if(!p3.Connect(m_strPOPsrv,m_strUserConn,m_strPassWord)){
  DWORD dwError = GetLastError();
  m_strInfo = p3.GetLastCommandResponse();
  UpdateData(FALSE);
  return;
 }
 m_strInfo="Connessione OK.";
 UpdateData(FALSE);
 Sleep(100L);
 if(!p3.Noop()){
  DWORD dwError = GetLastError();
  m_strInfo = p3.GetLastCommandResponse();
  UpdateData(FALSE);
 }
 m_strInfo="Leggo statistiche...";
 UpdateData(FALSE);
 Sleep(100L);
 int nMails;
 int nSize;
 if(!p3.Statistics(nMails, nSize)){
  DWORD dwError = GetLastError();
  m_strInfo = p3.GetLastCommandResponse();
  UpdateData(FALSE);
 }
 m_strInfo.Format("N. messaggi presenti: %d",nMails);
 UpdateData(FALSE);
 if(!p3.Disconnect()){
  DWORD dwError = GetLastError();
  m_strInfo = p3.GetLastCommandResponse();
  UpdateData(FALSE);
 }
}

*/