// FGSms.h : main header file for the FGSMS application
// By Francesco Germinara (c) 2001 - SofTech di Germinara Francesco
// Date : 10/01/2001

#if !defined(AFX_FGSMS_H__6B8367F5_0F24_11D5_A126_0050041038C1__INCLUDED_)
#define AFX_FGSMS_H__6B8367F5_0F24_11D5_A126_0050041038C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols


//************************************************************************
// Baud Rate Constants
//************************************************************************
const int Baud1200 = 3;
const int Baud2400 = 4;
const int Baud4800 = 5;
const int Baud9600 = 6;
const int Baud192K = 7;
const int Baud384K = 8;
const int Baud576K = 9;
const int Baud1152K = 10;


//************************************************************************
// Parity Constants
//************************************************************************
const int ParityNone = 0;
const int ParityEven = 1;
const int ParityOdd =  2;

//************************************************************************
// Stopbit Constants
//************************************************************************
const int StopBit1 = 0;
const int StopBit2 = 1;

//************************************************************************
// Wordlength Constants
//************************************************************************
const int WordLen7 = 2;
const int WordLen8 = 3;
//************************************************************************
// CardType Constants
//************************************************************************
const int CardWinApi = 0;
const int CardWcscVxD = 1;

//************************************************************************
// CommTick Constants
//************************************************************************
const int CommTickDefault = 0;
const int CommTickMilliSecond = 1;

/////////////////////////////////////////////////////////////////////////////
// CFGSmsApp:
// See FGSms.cpp for the implementation of this class
//

#include"CGsmAtCommands.h"
#include "CFGSmsDB.h"
#include "CTabCfgFgSms.h"
#include "CTabSMTPSrv.h"
#include "CTabGroup.h"
#include "CBseInfo.h"
#include "CBseData.h"
#include "CTabUser.h"
#include "smtp.h"
#include "Pop3.h"
#include "CParInterface.h"
#include "CTabCfgIO.h"
#include "CSplitMsg.h"
#include "CTabStoricoMsg.h"

class CFGSmsApp : public CWinApp
{
public:
	CFGSmsApp();

	CBseData m_bseDataStart; 

	BOOL m_bOkStarted;

	CString m_idSession;
	CString m_strSessionName;

	CBseInfo bseInfo;

	CSplitMsg m_spmsgDivided;

	CGsmAtCommands m_GsmAtCommands; //AT commands
	CFGSmsDB m_DB;   //Database dell'applicazione

	//Table
	CTabCfgFgSms *m_pTabCfgFgSms; //Configuration data
	CTabSMTPSrv  *m_pTabSMTPSrv;  //SMTP Servers databases
	CTabGroup    *m_pTabGroup;    //User Groups
 CTabUser     *m_pTabUser;     //Users 
 CTabUser     *m_pTabUserCopy;     //Users 
	CTabCfgIO    *m_pTabCfgIO;    //Digital I/O configuration
	CTabStoricoMsg *m_pTabStoricoMsg; //Log Message Received


//Mail Client
	CString m_strSMTPsrv;
	CString m_strPOPsrv;
	CString m_strPassWord;
	CString m_strUserConn;
	void CheckError(); 
    int m_nPort;
    CSMTPConnection::LoginMethod m_Authenticate;
    BOOL    m_bAutoDial;
    CString m_sBoundIP;
    CString m_sEncodingFriendly;
    CString m_sEncodingCharset;
    BOOL    m_bMime;
    BOOL    m_bHTML;
    CString m_sUsername;
    CString m_sPassword;
    CSMTPMessage* CreateMessage();
    CPop3Connection p3;

	CString	m_strAttach;
	CString	m_strCodForn;
	CString	m_strDenomForn;
	CString	m_strDestinatario;
	CString	m_strMsg;
	CString	m_strMittente;
	CString	m_strSubject;
	CString	m_strInfo;
	CString	m_strDisplayName;

//Hardware access to FgHwSms interface
    CParInterface m_fgHwSms;
	CString msgParStatus;


//Data member
	BOOL	m_bConfigurationEnable; //TRUE user can configure system
	CString	m_strWorkDir;           //Path for work files
	CString	m_strMemSharedName;     //Name of shared memory
	CString	m_strTmPolling;         //Time for polling to SMS

	int		m_nConnectionType;      //Type of connection DLR-3 ,DAU-9P, IrDA
	int		m_nDataBits;
	int		m_nParityType;
	int		m_nSerialPort;
	int		m_nStopBits;
	int		m_nBaudRate;
	BOOL    m_bEnableLogs;

	int    m_bUseParallelPort;  //Use fgHwSms interface bits coded 00000000 = None
	                             //                                 00000xx1 = Lpt1 have fgHwInterface
	                             //                                 00000x1x = Lpt2 have fgHwInterface
		                         //                                 000001xx = Lpt3 have fgHwInterface
	BOOL    m_bUseIOcard;        //Use other hw interface
	int     m_naLptAddr[3];      //List of LPTs address
	int     m_nParallelPort;     //Index of n Port Present

	CString m_strNCentroServizi;
	CString m_strConfigurationEnable;
	CString m_strConnectionType;
	CString m_strDataBits;
	CString m_strParityType;
	CString m_strSerialPort;
	CString m_strStopBits;
	CString m_strBaudRate;
	CString m_strSmtpSvr;
	CString m_strParityMode;
	CString m_PassWordCfg;
	CString m_strEnableLogs;
	CString m_strUseParallelPort;
	CString m_strParallelPortNum;
	CString m_strUseIOcard;

    BOOL LoadConfig();             //Load configuration values
	BOOL SaveConfig();             //Save configuration values


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFGSmsApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CFGSmsApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FGSMS_H__6B8367F5_0F24_11D5_A126_0050041038C1__INCLUDED_)
