CREATE TABLE [dbo].[CFGSMTP] (
	[SrvName] [char] (100) NOT NULL ,
	[DomainName] [char] (100) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[CFGFGSMS] (
	[IdSess] [char] (4) NOT NULL ,
	[SmtpSvr] [char] (100) NULL ,
	[ComPort] [char] (1) NULL ,
	[BaudRate] [char] (10) NULL ,
	[DataBit] [char] (1) NULL ,
	[StopBit] [char] (1) NULL ,
	[Parity] [char] (1) NULL ,
	[TypeParity] [char] (1) NULL ,
	[Mode] [char] (1) NULL ,
	[SMSCNumber] [char] (50) NULL ,
	[PollingTime] [char] (5) NULL ,
	[DirLogFiles] [char] (255) NULL ,
	[NameSharedMem] [char] (50) NULL ,
	[PassWordCfg] [char] (10) NULL ,
	[CfgMode] [char] (1) NULL ,
	[EnableLogs] [char] (1) NULL ,
	[UseParallelPort] [char] (1) NULL ,
	[ParallelPortNum] [char] (1) NULL ,
	[UseIOcard] [char] (1) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[CFGGROUP] (
	[IdGroup] [char] (10) NOT NULL ,
	[Description] [char] (100) NULL ,
	[CostOfService] [char] (15) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[CFGIO] (
	[memAddr] [char] (1) NOT NULL ,
	[nBit] [char] (1) NOT NULL ,
	[type] [char] (1) NOT NULL ,
	[des] [char] (15) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[CFGUSER] (
	[IdUser] [char] (10) NOT NULL ,
	[UsrName] [char] (100) NULL ,
	[UsrGrp] [char] (10) NULL ,
	[ServiceEnable] [char] (1) NULL ,
	[ExpirationDate] [char] (8) NULL ,
	[ChkReqDays] [char] (3) NULL ,
	[mailAddress] [char] (100) NULL ,
	[mailPassword] [char] (50) NULL ,
	[mailPOP3svr] [char] (100) NULL ,
	[phoneNumber] [char] (50) NULL ,
	[phoneSIMNumber] [char] (50) NULL ,
	[phonePassword] [char] (50) NULL ,
	[CMOnlyOne] [char] (1) NULL ,
	[CMShortMode] [char] (1) NULL ,
	[CMNotifyEnable] [char] (1) NULL ,
	[CMFlashMode] [char] (1) NULL ,
	[PMStandByMsg] [char] (1) NULL ,
	[PMSendConfirm] [char] (1) NULL ,
	[DMCanDeleteMsg] [char] (1) NULL ,
	[DMMakeCopyMsg] [char] (1) NULL ,
	[STCanScheduleMsg] [char] (1) NULL ,
	[STCanUseBatchCmd] [char] (1) NULL ,
	[CostOfService] [char] (15) NULL ,
	[mailAccount] [char] (50) NULL ,
	[nMsgSend] [char] (10) NULL ,
	[nMsgReceived] [char] (10) NULL ,
	[nLpt] [char] (1) NULL ,
	[nBits] [char] (3) NULL ,
	[nLastValue] [char] (3) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[LOGFGSMS] (
	[IdSess] [char] (4) NOT NULL ,
	[IdUser] [char] (10) NOT NULL ,
	[Date] [char] (8) NOT NULL ,
	[Time] [char] (8) NOT NULL ,
	[Description] [char] (255) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[STATISTICS] (
	[IdUser] [char] (10) NOT NULL ,
	[IdMsg] [char] (15) NOT NULL ,
	[DateMSG] [char] (8) NOT NULL ,
	[TimeMSG] [char] (8) NOT NULL ,
	[TypeOper] [char] (10) NOT NULL ,
	[Command] [char] (10) NOT NULL ,
	[Message] [char] (255) NULL ,
	[TelNumber] [char] (50) NULL ,
	[StatusMSG] [char] (2) NULL ,
	[ReservedStatus] [char] (1) NULL ,
	[ScheduledData] [char] (8) NULL ,
	[ScheduledTime] [char] (8) NULL ,
	[ScheduledExecuted] [char] (1) NULL ,
	[BatchCmd] [char] (255) NULL ,
	[BatchCmdStatus] [char] (2) NULL ,
	[IdGrp] [char] (10) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[StoricoMsg] (
	[idMSG] [char] (10) NOT NULL ,
	[textMSG] [char] (160) NULL ,
	[flgSts] [char] (1) NULL ,
	[nTelef] [char] (50) NOT NULL ,
	[data] [char] (8) NOT NULL ,
	[ora] [char] (8) NOT NULL ,
	[idUser] [char] (10) NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[CFGSMTP] WITH NOCHECK ADD 
	CONSTRAINT [PK_CFGSMTP] PRIMARY KEY  NONCLUSTERED 
	(
		[SrvName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[CFGFGSMS] WITH NOCHECK ADD 
	CONSTRAINT [PK_CFGFGSMS] PRIMARY KEY  NONCLUSTERED 
	(
		[IdSess]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[CFGGROUP] WITH NOCHECK ADD 
	CONSTRAINT [PK_CFGGROUP] PRIMARY KEY  NONCLUSTERED 
	(
		[IdGroup]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[LOGFGSMS] WITH NOCHECK ADD 
	CONSTRAINT [PK_LOGFGSMS] PRIMARY KEY  NONCLUSTERED 
	(
		[IdSess],
		[IdUser],
		[Date],
		[Time]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[STATISTICS] WITH NOCHECK ADD 
	CONSTRAINT [PK_STATISTICS] PRIMARY KEY  NONCLUSTERED 
	(
		[IdUser],
		[IdMsg],
		[DateMSG],
		[TimeMSG],
		[TypeOper],
		[Command]
	)  ON [PRIMARY] 
GO

