//----------------------------------------------------------------
// Nome Progetto        : Labels.exe
// Nome file            : qtListCtrl.cpp
// Classe               : qtListCtrl
//----------------------------------------------------------------
// Descrizione          : Classe Gestione List View Virtuali
// Data 1 Realizzazione: 22/05/2001
// Autore               : SofTech  di Francesco Germinara  
// Copyright (c)        : SofTech  di Francesco Germinara  
//----------------------------------------------------------------
// Storia:
// 
//----------------------------------------------------------------

#include "stdafx.h"
#include "qtListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// qtListCtrl

qtListCtrl::qtListCtrl(CWnd *pWnd,UINT nID,CRect& rect,void *m_pTabGen)
{
  m_pTabGenerica = ((CTabVirtual *)m_pTabGen);
  Create(WS_CHILD | WS_EX_LEFT | WS_EX_LTRREADING| WS_TABSTOP|WS_VISIBLE | WS_BORDER| LVS_SINGLESEL | LVS_REPORT  |LVS_OWNERDATA ,rect,pWnd,nID);
  ModifyStyle(WS_GROUP | LVS_EDITLABELS,0);
}

qtListCtrl::~qtListCtrl()
{
}


BEGIN_MESSAGE_MAP(qtListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(qtListCtrl)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// qtListCtrl message handlers
void qtListCtrl::PrepareCache(int /*iFrom*/, int /*iTo*/)
{
}

//Leggo Info dalla Tabella del DataBase
void qtListCtrl::GetDispInfo(LVITEM* pItem)
{
 if(pItem->mask & LVIF_TEXT)
 {
	m_pTabGenerica->GetRecordForDispInfo(this,pItem);
 }
}

int qtListCtrl::FindItem(int /*iStart*/, LVFINDINFO* /*plvfi*/)
{
	return -1;
}

BOOL qtListCtrl::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{

	if(message == WM_NOTIFY)
	{
		NMHDR* phdr = (NMHDR*)lParam;
     
		// these 3 notifications are only sent by virtual listviews
		switch(phdr->code)
		{
		case LVN_GETDISPINFO:
			{
				NMLVDISPINFO* pLvdi;
				pLvdi = (NMLVDISPINFO*)lParam;
				GetDispInfo(&pLvdi->item);
			}
			if(pResult != NULL)
			{
				*pResult = 0;
			}
			break;
		case LVN_ODCACHEHINT:
			{
				NMLVCACHEHINT* pHint = (NMLVCACHEHINT*)lParam;

				PrepareCache(pHint->iFrom, pHint->iTo);
			}
			if(pResult != NULL)
			{
				*pResult = 0;
			}
			break;
		case LVN_ODFINDITEM:
			{
				NMLVFINDITEM* pFindItem = (NMLVFINDITEM*)lParam;
				int i = FindItem(pFindItem->iStart, &pFindItem->lvfi);
				if(pResult != NULL)
				{
					*pResult = i;
				}
			}
			break;

		default:
			return CListCtrl::OnChildNotify(message, wParam, lParam, pResult);
		}
	}
	else
		return CListCtrl::OnChildNotify(message, wParam, lParam, pResult);

	return TRUE;
}



BOOL qtListCtrl::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.dwExStyle=WS_EX_CLIENTEDGE | WS_EX_CLIENTEDGE | WS_EX_NOPARENTNOTIFY;
	return CListCtrl::PreCreateWindow(cs);
}
